#! /usr/bin/python
import pygtk
import gtk
import os
import time
import ConfigParser
import webbrowser
import locale
import time
import socket
import gobject
import select

#Try to import psyco engine
try:
        import psyco
        psyco.full()
	print 'Psyco engine successfully imported\n'
except ImportError:
        pass
	
class IndexWindow:
	
    def __init__(self):
	################################################################################
	#Python 
	################################################################################
	#Import data
	self.sysep = os.sep
	#try to open Nixory configuration 
	dataconf = os.path.isfile('Data' + self.sysep + 'nistin.dll')
	print 'Loading Nixory configuration...'
	
	if dataconf is True:
	
	        print 'Configuration file succesfully found'
		state = 1
		datain = open('Data' + self.sysep + 'nistin.dll', 'r')
		
		#Load configuration
		self.config = ConfigParser.ConfigParser()
                self.config.read("Data" + self.sysep + "nistin.dll")
		
		#Assign stats variables
		self.nscan = int(self.config.get('MainTable', 'Scans'))
		self.nfound = int(self.config.get('MainTable','Found'))
		self.nrem = int(self.config.get('MainTable','Removed'))
		self.npot = int(self.config.get('MainTable','PotM'))
		self.nrhigh = int(self.config.get('MainTable','RHigh'))
		self.nrmed = int(self.config.get('MainTable','RMed'))
		self.nrlow = int(self.config.get('MainTable','RLow'))
		self.spath = str(self.config.get('Config','cookie_path'))
		self.sclow = str(self.config.get('Config','ignore_low'))
		self.scmed = str(self.config.get('Config','ignore_med'))
		self.schigh = str(self.config.get('Config','ignore_high'))
		self.sciceye = str(self.config.get('Config','Ice_Eye'))
		self.scavv = str(self.config.get('Config','Ice_Eye_Adv'))
		self.cobjn = str(self.config.get('Config','Ice_Eye_ig'))
		self.ncobjn = str(self.config.get('Config','Ice_Eye_nig'))
		self.scwrite = str(self.config.get('Config','writelog'))
		self.writedet = str(self.config.get('Config','wl_details'))
		self.maxlogs = str(self.config.get('Config','max_logs'))
		self.lastupd = str(self.config.get('Config','lastupd'))
		self.lang = str(self.config.get('Config','language'))
		self.setlang = False
		self.setupd = True
			
		
	else:
		print 'Configuration file not found!'
		state = 2
		self.nscan = 0
		self.nfound = 0
		self.nrem = 0
		self.npot = 0
		self.nrhigh = 0
		self.nrmed = 0
		self.nrlow = 0
	        self.spath = 'None'
	        self.sclow = 'False'
		self.scmed = 'False'
		self.schigh = 'False'
		self.sciceye = 'True'
		self.scavv = 'True'
		self.cobjn = 'False'
		self.ncobjn = 'True'
		self.scwrite = 'True'
		self.writedet = 'False'
		self.maxlogs = '25'
		self.lastupd = '0/0/0'
		self.lang = 'English'
		self.setlang = False
	
	#Load Definitions database
	self.LocDatabase = {}
	self.LinkDatabase = {}
	self.database = ConfigParser.ConfigParser()
	self.database.read("Data" + self.sysep + "ndefx.dll")
        self.dbtot = self.database.get('Definitions','nt')
	self.dbt = self.database.get('Definitions','cp')
	self.dbv = self.database.get('Definitions','dbv')
	self.dbd = self.database.get('Definitions','dbd')
	self.dbds = self.database.get('Definitions','dbds')
	self.dbid = self.database.get('Definitions','dbid')
	self.dbnum = self.database.get('Definitions','dbnum')
	self.sepjk = self.database.get('Definitions','sep')
	i = 1
	m = 1
	while i <= int(self.dbtot):
		dbname = self.database.get('Definitions', str(i))
		self.LocDatabase[dbname] = {}
		db = {}
		n = self.database.get('Definitions','nt' + str(i))
		b = 1
		while b <= int(n):
			self.LinkDatabase['dm' + str(m)] = self.database.get('Definitions','dm' + str(m)).split(self.sepjk)
			db[self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '1')] = [self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '2'), self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '3')]
			b = b + 1
			m = m + 1
		self.LocDatabase[dbname] = db
		i = i + 1
	print 'Definitions database succesfully loaded'
	#Load language
	if 'English' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangen.dll")
		
	if 'Italian' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangit.dll")
        
        if 'Dutch' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangdu.dll")
		
	if 'Spanish' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangsp.dll")
	if 'SpAR' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangspar.dll")
	if 'Catalan' in self.lang:
		#Load language file
	        self.config = ConfigParser.ConfigParser()
	        self.config.read("Data" + self.sysep + "mlangcat.dll")
		
	#add stocks
	gtk.stock_add([(gtk.STOCK_YES, self.config.get('LanguageFile','69').decode(locale.getpreferredencoding()).encode("utf-8"), 0, 0, "")])
	gtk.stock_add([(gtk.STOCK_NO, self.config.get('LanguageFile','70').decode(locale.getpreferredencoding()).encode("utf-8"), 0, 0, "")])
		
	gtk.stock_add([(gtk.STOCK_APPLY, self.config.get('LanguageFile','33').decode(locale.getpreferredencoding()).encode("utf-8"), 0, 0, "")])
	gtk.stock_add([(gtk.STOCK_CANCEL, self.config.get('LanguageFile','26').decode(locale.getpreferredencoding()).encode("utf-8"), 0, 0, "")])
	
	#Add Theme
	self.nixoryicth = gtk.IconFactory()
	
	#Load Icons
	apply_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "ok.png")
	apply_stockset = gtk.IconSet(apply_stock)
	cancel_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "nope.png")
	cancel_stockset = gtk.IconSet(cancel_stock)
	folder_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "folder.png")
	folder_stockset = gtk.IconSet(folder_stock)
	home_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "home.png")
	home_stockset = gtk.IconSet(home_stock)
	hd_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "harddisk.png")
	hd_stockset = gtk.IconSet(hd_stock)
	floppy_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "floppy.png")
        floppy_stockset = gtk.IconSet(floppy_stock)
	cdrom_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "cdrom.png")
        cdrom_stockset = gtk.IconSet(cdrom_stock)
	delete_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "delete.png")
        delete_stockset = gtk.IconSet(delete_stock)
	new_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "new.png")
        new_stockset = gtk.IconSet(new_stock)
	error_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "error.png")
        error_stockset = gtk.IconSet(error_stock)
	warning_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "warning.png")
        warning_stockset = gtk.IconSet(warning_stock)
	question_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "question.png")
        question_stockset = gtk.IconSet(question_stock)
	self.info_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "gear.png")
        self.info_stockset = gtk.IconSet(self.info_stock)
	self.net_stock = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "updates.png")
        self.net_stockset = gtk.IconSet(self.net_stock)
	
	#Add Icons
	self.nixoryicth.add(gtk.STOCK_APPLY, apply_stockset)
	self.nixoryicth.add(gtk.STOCK_OK, apply_stockset)
	self.nixoryicth.add(gtk.STOCK_YES, apply_stockset)
	self.nixoryicth.add(gtk.STOCK_CANCEL, cancel_stockset)
	self.nixoryicth.add(gtk.STOCK_NO, cancel_stockset)
	self.nixoryicth.add(gtk.STOCK_DIRECTORY, folder_stockset)
	self.nixoryicth.add(gtk.STOCK_HOME, home_stockset)
	self.nixoryicth.add(gtk.STOCK_HARDDISK, hd_stockset)
	self.nixoryicth.add(gtk.STOCK_FLOPPY, floppy_stockset)
	self.nixoryicth.add(gtk.STOCK_CDROM, cdrom_stockset)
	self.nixoryicth.add(gtk.STOCK_REMOVE, delete_stockset)
	self.nixoryicth.add(gtk.STOCK_ADD, new_stockset)
	self.nixoryicth.add(gtk.STOCK_DIALOG_ERROR, error_stockset)
	self.nixoryicth.add(gtk.STOCK_DIALOG_WARNING, warning_stockset)
	self.nixoryicth.add(gtk.STOCK_DIALOG_QUESTION, question_stockset)
	self.nixoryicth.add(gtk.STOCK_DIALOG_INFO, self.info_stockset)
	
	#Set Theme
	self.nixoryicth.add_default()
	
	################################################################################
	#PyGTK GUI Interface
	################################################################################
	#INDEX WINDOWS
	#Window
        self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.connect("delete_event", self.delete_event)
	self.win.connect("destroy", self.destroy)
	self.win.set_position(gtk.WIN_POS_CENTER)
	self.win.set_default_size(550, 316)
        self.win.set_resizable(True)
        self.win.set_title('Nixory')
	gtk.window_set_default_icon_from_file('Icons' + self.sysep + 'Nixory_small.png')
	
	#Table container
	self.indextable = gtk.Table(4, 3, False)
	
	#HBox container
	self.buttonsbox = gtk.HBox(True, 0)
	
	#Add Pixbuf
	scans_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "scans.png")
	found_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "found.png")
	removed_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "removed.png")
	risk_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "risk.png")
	high_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "high.png")
	medium_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "medium.png")
	low_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "low.png")
	
	#ListStore
        self.liststore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
        self.liststore.append([scans_im ,self.nscan, self.config.get('LanguageFile','01').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([found_im ,self.nfound, self.config.get('LanguageFile','02').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([removed_im ,self.nrem, self.config.get('LanguageFile','03').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([risk_im ,self.npot, self.config.get('LanguageFile','96').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([high_im ,self.nrhigh, self.config.get('LanguageFile','04').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([medium_im ,self.nrmed, self.config.get('LanguageFile','05').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.liststore.append([low_im ,self.nrlow, self.config.get('LanguageFile','06').decode(locale.getpreferredencoding()).encode("utf-8")])
	
	#TreeView
	self.treeview = gtk.TreeView(self.liststore)
	self.treeview.set_rules_hint(True)
	
	#TreeViewColums
	self.columnint = gtk.TreeViewColumn('            ')
	self.columnint.set_resizable(True)
	self.columnstr = gtk.TreeViewColumn(self.config.get('LanguageFile','07').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Append columns
	self.treeview.append_column(self.columnint)
	self.treeview.append_column(self.columnstr)
	
	#Cellrenderers2
	self.cellpix = gtk.CellRendererPixbuf()
	self.cellint = gtk.CellRendererText()
	self.cellstr = gtk.CellRendererText()
	
	#add cell renderers
	self.columnint.pack_start(self.cellpix, True)
	self.columnint.pack_start(self.cellint, True)
	self.columnstr.pack_start(self.cellstr, True)
	
	#set attributes
	self.columnint.set_attributes(self.cellpix, pixbuf=0)
	self.columnint.set_attributes(self.cellint, text=1)
	self.columnstr.set_attributes(self.cellstr, text=2)
	self.cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
	
	#Status Bar
	self.dbbar = gtk.Statusbar()
	self.dbbar.push(1, ':::' + self.config.get('LanguageFile','104').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' + self.dbv + ' (' + self.dbd + ')')
	
	#Box Button Quit
	self.quitbox = gtk.HBox(False, 0)
	self.quitimage = gtk.Image()
	self.quitimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'quit.png')
	self.quitlab = gtk.Label(self.config.get('LanguageFile','08').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.quitbox.pack_start(self.quitimage, False, 1)
	self.quitbox.pack_start(self.quitlab, True, 1)
	self.quitbut = gtk.Button()
	self.quitbut.add(self.quitbox)
	self.quitbut.connect('clicked', self.destroyw)
	
	#Button Scan
	self.scanbox = gtk.HBox(False, 0)
	self.scanimage = gtk.Image()
	self.scanimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'scan_now.png')
	self.scanlab = gtk.Label('  ' + self.config.get('LanguageFile','09').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.scanbox.pack_start(self.scanimage, False)
	self.scanbox.pack_start(self.scanlab, False)
	self.scanbut = gtk.Button()
	self.scanbut.add(self.scanbox)
	self.scanbut.connect('clicked', self.refresh)
	self.scanbut.connect('clicked', self.winscan)
	
	if state == 1:
		self.scanbut.set_sensitive(True)
	else:
		self.scanbut.set_sensitive(False)
	
	#Label
	self.status = gtk.Label()
	if state == 1:
		a = self.config.get('LanguageFile','10').decode(locale.getpreferredencoding()).encode("utf-8")
		s = a.decode(locale.getpreferredencoding()).encode("utf-8")
		self.status.set_text(self.config.get('LanguageFile','10').decode(locale.getpreferredencoding()).encode("utf-8"))
	if state == 2:
		self.status.set_text(self.config.get('LanguageFile','11').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#box packstart
	self.buttonsbox.pack_start(self.quitbut, True, True)
	self.buttonsbox.pack_start(self.scanbut, True, True)
	
	#File menu
	self.file_menu = gtk.Menu()
	
	self.quit_item = gtk.ImageMenuItem(self.config.get('LanguageFile','08').decode(locale.getpreferredencoding()).encode("utf-8"))
        self.image = gtk.Image()
        self.image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'quit.png')
        self.quit_item.set_image(self.image)
	self.quit_item.connect_object('activate', self.destroy, None)
	
	self.file_menu.append(self.quit_item)
	
	#Options menu
	self.options_menu = gtk.Menu()
	
	self.configure_item = gtk.ImageMenuItem(self.config.get('LanguageFile','12').decode(locale.getpreferredencoding()).encode("utf-8")) 
	self.configure_image = gtk.Image()
	self.configure_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'preferences.png') 
	self.configure_item.set_image(self.configure_image)
	self.configure_item.connect('activate', self.refresh)
	self.configure_item.connect('activate', self.preference_win)
	
	if state == 1:
		self.configure_item.set_sensitive(True)
	else:
		self.configure_item.set_sensitive(False)
	
	self.options_menu.append(self.configure_item)
	
	#Actions menu
	self.act_menu = gtk.Menu()
	
	self.scan_item = gtk.ImageMenuItem(self.config.get('LanguageFile','09').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.scan_image = gtk.Image()
	self.scan_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'scan_now_small.png')
	self.scan_item.set_image(self.scan_image)
	self.scan_item.connect('activate', self.refresh)
	self.scan_item.connect('activate', self.winscan)
	
	self.update_item = gtk.ImageMenuItem(self.config.get('LanguageFile','109').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.update_image = gtk.Image()
	self.update_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'update.png')
	self.update_item.set_image(self.update_image)
	self.update_item.connect('activate', self.refresh)
	self.update_item.connect('activate', self.update_win)
        
        self.evlog_item = gtk.ImageMenuItem(self.config.get('LanguageFile','148').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.evlog_image = gtk.Image()
	self.evlog_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'eventlog.png')
	self.evlog_item.set_image(self.evlog_image)
	self.evlog_item.connect('activate', self.refresh)
	self.evlog_item.connect('activate', self.win_eventlog)
	
	if state == 1:
		self.scan_item.set_sensitive(True)
	else:
		self.scan_item.set_sensitive(False)
	
	
	self.act_menu.append(self.scan_item)
	self.act_menu.append(self.update_item)
        self.act_menu.append(self.evlog_item)
	
	#Language menu
	self.lang_menu = gtk.Menu()
	self.eng_item = gtk.ImageMenuItem(self.config.get('LanguageFile','98').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'English' in self.lang:
	    self.eng_image = gtk.Image()
            self.eng_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.eng_image = gtk.Image()
            self.eng_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.eng_item.set_image(self.eng_image)
	self.eng_item.connect_object('activate', self.change_eng, None)
	
	self.ita_item = gtk.ImageMenuItem(self.config.get('LanguageFile','99').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'Italian' in self.lang:
	    self.ita_image = gtk.Image()
            self.ita_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.ita_image = gtk.Image()
            self.ita_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.ita_item.set_image(self.ita_image)
	self.ita_item.connect_object('activate', self.change_ita, None)
	
	
	self.du_item = gtk.ImageMenuItem(self.config.get('LanguageFile','100').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'Dutch' in self.lang:
	    self.du_image = gtk.Image()
            self.du_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.du_image = gtk.Image()
            self.du_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.du_item.set_image(self.du_image)
	self.du_item.connect_object('activate', self.change_du, None)
	
	self.sp_item = gtk.ImageMenuItem(self.config.get('LanguageFile','101').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'Spanish' in self.lang:
	    self.sp_image = gtk.Image()
            self.sp_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.sp_image = gtk.Image()
            self.sp_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.sp_item.set_image(self.sp_image)
	self.sp_item.connect_object('activate', self.change_sp, None)
	
	self.spar_item = gtk.ImageMenuItem(self.config.get('LanguageFile','102').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'SpAR' in self.lang:
	    self.spar_image = gtk.Image()
            self.spar_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.spar_image = gtk.Image()
            self.spar_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.spar_item.set_image(self.spar_image)
	self.spar_item.connect_object('activate', self.change_spar, None)
	
	self.cat_item = gtk.ImageMenuItem(self.config.get('LanguageFile','103').decode(locale.getpreferredencoding()).encode("utf-8"))
	if 'Catalan' in self.lang:
	    self.cat_image = gtk.Image()
            self.cat_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	else:
	    self.cat_image = gtk.Image()
            self.cat_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'cancel.png')
        self.cat_item.set_image(self.cat_image)
	self.cat_item.connect_object('activate', self.change_cat, None)
	
	if state != 1:
		self.eng_item.set_sensitive(False)
		self.ita_item.set_sensitive(False)
		self.du_item.set_sensitive(False)
		self.sp_item.set_sensitive(False)
		self.spar_item.set_sensitive(False)
		self.cat_item.set_sensitive(False)
		
	        
	
	self.lang_menu.append(self.eng_item)
	self.lang_menu.append(self.ita_item)
	self.lang_menu.append(self.du_item)
	self.lang_menu.append(self.sp_item)
	self.lang_menu.append(self.spar_item)
	self.lang_menu.append(self.cat_item)
	
	#Help menu
	self.help_menu =gtk.Menu()
	
	self.about_item = gtk.ImageMenuItem('About')
	self.about_image = gtk.Image()
	self.about_image.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'info.png')
	self.about_item.set_image(self.about_image)
	self.about_item.connect('activate', self.win_about)
	
	self.help_menu.append(self.about_item)
	
	
	#Add menus
	self.menu_bar = gtk.MenuBar()
	
	self.file_item = gtk.MenuItem(self.config.get('LanguageFile','71').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.file_item.set_submenu(self.file_menu)
	
	self.options_item = gtk.MenuItem(self.config.get('LanguageFile','13').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.options_item.set_submenu(self.options_menu)
	
	self.scan_item = gtk.MenuItem(self.config.get('LanguageFile','14').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.scan_item.set_submenu(self.act_menu)
	
	self.lang_item = gtk.MenuItem(self.config.get('LanguageFile','15').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.lang_item.set_submenu(self.lang_menu)
	
	self.about_item = gtk.MenuItem(self.config.get('LanguageFile','16').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.about_item.set_submenu(self.help_menu)
	
	self.menu_bar.append(self.file_item)
	self.menu_bar.append(self.options_item)
	self.menu_bar.append(self.scan_item)
	self.menu_bar.append(self.lang_item)
	self.menu_bar.append(self.about_item)
	
	
	#show
	self.indextable.attach(self.menu_bar, 0, 3, 0, 1, gtk.FILL, gtk.FILL)
	self.indextable.attach(self.treeview, 0, 3, 1, 2, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	self.indextable.attach(self.buttonsbox, 0, 1, 2, 3, 0 , 0)
	self.indextable.attach(self.status, 1, 3, 2, 3, gtk.EXPAND|gtk.FILL , 0)
	self.indextable.attach(self.dbbar, 0, 3, 3, 4, gtk.FILL, gtk.FILL)
	self.win.add(self.indextable)
	self.win.show_all()
	
	#Focus
	self.win.set_focus(None)
	
    def win_about(self,widget):
	#Dialog 
        self.aboutwin = gtk.Dialog('Nixory About', None, 0, (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
	self.aboutwin.set_modal(True)
	self.aboutwin.set_transient_for(self.win)
	self.aboutwin.set_default_size(262, 295)
	self.aboutwin.set_position(gtk.WIN_POS_CENTER)
	
	#Content
	self.im = gtk.Image()
	self.im.set_from_file('Icons' + self.sysep + 'Nixory.png')
	self.namelab = gtk.Label()
	self.namelab.set_markup('<b>:::Nixory 0.4.1::: </b>')
	self.atlab = gtk.Label()
	self.atlab.set_markup('<b>' + self.config.get('LanguageFile','128').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>')
	self.aklab = gtk.Label()
	self.aklab.set_markup('<b>' + self.config.get('LanguageFile','129').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>')
	self.aboutwin.vbox.pack_start(self.namelab)
	self.aboutwin.vbox.pack_start(self.im)
	self.aboutwin.vbox.pack_start(gtk.Label('                  ' + self.config.get('LanguageFile','17').decode(locale.getpreferredencoding()).encode("utf-8") + '                  '))
	self.ggwin = gtk.ScrolledWindow()
	self.ggbox = gtk.VBox()
	self.ggbox.pack_start(self.atlab)
	self.ggbox.pack_start(gtk.Label(self.config.get('LanguageFile','18').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','19').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','20').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','21').decode(locale.getpreferredencoding()).encode("utf-8") + '\n'))
	self.ggbox.pack_start(self.aklab)
	self.tranlabel = gtk.Label()
	self.tranlabel.set_markup('<b>' + self.config.get('LanguageFile','130').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '  ' + self.config.get('LanguageFile','131').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','132').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + '<b>' + self.config.get('LanguageFile','133').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '  ' + self.config.get('LanguageFile','134').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','135').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + '<b>' + self.config.get('LanguageFile','136').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '  ' + self.config.get('LanguageFile','137').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','138').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + '<b>' + self.config.get('LanguageFile','139').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '  ' + '\n' + self.config.get('LanguageFile','140').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','141').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + '<b>' + self.config.get('LanguageFile','142').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '  ' + self.config.get('LanguageFile','143').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','144').decode(locale.getpreferredencoding()).encode("utf-8") + '\n\n' + '<b>' + self.config.get('LanguageFile','145').decode(locale.getpreferredencoding()).encode("utf-8") + '</b>' + '\n' + self.config.get('LanguageFile','146').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','147').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.ggbox.pack_start(self.tranlabel)
	self.ggwin.add_with_viewport(self.ggbox)
        self.aboutwin.vbox.pack_start(self.ggwin)
	
	#Show dialog
	self.aboutwin.show_all()
	self.aboutwin.set_focus(None)
	
	#View response
	response = self.aboutwin.run()
	if response == gtk.RESPONSE_ACCEPT:
	           self.aboutwin.destroy()
        self.aboutwin.destroy()
	
    def preference_win(self,widget):
	
	#Preference Window
	self.prwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.prwin.connect("delete_event", self.delete_event)
	self.prwin.set_position(gtk.WIN_POS_CENTER)
	self.prwin.set_default_size(350, 285)
        self.prwin.set_resizable(True)
        self.prwin.set_title(self.config.get('LanguageFile','22').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.prwin.set_modal(True)
	self.prwin.set_transient_for(self.win)
	self.adj = gtk.Adjustment(float(self.maxlogs), 1, 50, 0, 0, 0)
	
	#Main Table
	self.maintable = gtk.Table(2, 2, False)
	
	#Notebook
	self.prnotebook = gtk.Notebook()
	self.prnotebook.set_tab_pos(gtk.POS_TOP)
	
	##General Section
	
	#Table
	self.prtable = gtk.Table(3, 15, False)
	
	#Space Box
	self.spbox = gtk.Label('\n\n\n\n')
	
	#Box Button Browser
	self.browbox = gtk.HBox(False, 0)
	self.browimage = gtk.Image()
	self.browimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'browser.png')
	self.browlab = gtk.Label('  ' + self.config.get('LanguageFile','23').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.browbox.pack_start(self.browimage, False, 1)
	self.browbox.pack_start(self.browlab, True, 1)
	self.browbut = gtk.Button()
	self.browbut.add(self.browbox)
	self.browbut.connect('clicked', self.browser)
	
	#Box Button Clean
	self.cleanbox = gtk.HBox(False, 0)
	self.cleanimage = gtk.Image()
	self.cleanimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'clear.png')
	self.cleanlab = gtk.Label(' ' +self.config.get('LanguageFile','24').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.cleanbox.pack_start(self.cleanimage, False, 1)
	self.cleanbox.pack_start(self.cleanlab, True, 1)
	self.cleanbut = gtk.Button()
	self.cleanbut.add(self.cleanbox)
	self.cleanbut.connect('clicked', self.clean_text)
	
	#Button box
	self.pbox = gtk.HBox(False, 0)
	self.pbox.pack_start(self.browbut, False, 1)
	self.pbox.pack_start(self.cleanbut, False, 1)
	
	
	#Label path
	if 'English' in self.lang:
		spaces1 = 32
		spaces2 = 38
		spaces3 = 26
		spaces4 = 38
	if 'Italian' in self.lang:
		spaces1 = 32
		spaces2 = 48
		spaces3 = 40
		spaces4 = 38
	if 'Dutch' in self.lang:
		spaces1 = 32
		spaces2 = 43
		spaces3 = 20
		spaces4 = 38
	if 'Spanish' in self.lang:
		spaces1 = 32
		spaces2 = 45
		spaces3 = 20
		spaces4 = 38
	if 'SpAR' in self.lang:
		spaces1 = 32
		spaces2 = 45
		spaces3 = 20
		spaces4 = 38
	if 'Catalan' in self.lang:
		spaces1 = 32
		spaces2 = 45
		spaces3 = 20
		spaces4 = 38
		
	self.pathlab = gtk.Label('   ' + self.config.get('LanguageFile','27').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' * spaces1)
	self.space = gtk.Label('    ')
	self.allowlab = gtk.Label('\n' + self.config.get('LanguageFile','28').decode(locale.getpreferredencoding()).encode("utf-8") + (' ' * spaces2) + '\n')
	self.infot = gtk.Label(' ' * spaces4 + self.config.get('LanguageFile','73').decode(locale.getpreferredencoding()).encode("utf-8") + '\n')
	
	#Separator
	self.sep = gtk.HSeparator()
	self.sep2 = gtk.HSeparator()
	
	#Entry path
	self.fcentry = gtk.Entry(0)
	
	#Check buttons
	self.ign1 = gtk.CheckButton(self.config.get('LanguageFile','30').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.ign2 = gtk.CheckButton(self.config.get('LanguageFile','31').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.ign3 = gtk.CheckButton(self.config.get('LanguageFile','32').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Attach
	self.prtable.attach(self.infot,0, 1, 0, 1,gtk.EXPAND|gtk.EXPAND, 0)
	self.prtable.attach(self.pathlab,0, 1, 1, 2,0, 0)
	self.prtable.attach(self.fcentry,0, 3, 2, 3, gtk.EXPAND|gtk.FILL, 0)
	self.prtable.attach(self.pbox,2, 3, 3, 4, 0, 0)
	self.prtable.attach(self.space,1, 3, 3, 4, gtk.EXPAND, 0)
	self.prtable.attach(self.sep,0, 3, 4, 5, gtk.EXPAND|gtk.FILL,0)
	self.prtable.attach(self.allowlab,0, 1, 5, 6, 0, 0)
	self.prtable.attach(self.ign1,0, 2, 6, 7, gtk.FILL, 0)
	self.prtable.attach(self.ign2,0, 2, 7, 8, gtk.FILL, 0)
	self.prtable.attach(self.ign3,0, 2, 8, 9, gtk.FILL, 0)
	self.prtable.attach(self.sep2,0, 3, 9, 10, gtk.FILL, 0)
	self.prtable.attach(self.spbox,0, 3, 10, 13, gtk.EXPAND|gtk.EXPAND, 0)
	
	
	#Label box General
	self.generalbox = gtk.HBox(False, 0)
	self.generalimage = gtk.Image()
	self.generalimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'general.png')
	self.generallab = gtk.Label(' ' + self.config.get('LanguageFile','74').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.generalimage.show()
	self.generallab.show()
	self.generalbox.pack_start(self.generalimage, True, 1)
	self.generalbox.pack_start(self.generallab, False, 1)
	
	##Ice Eye Section
	
	#Table
	self.eyetable = gtk.Table(3, 9, False)
	
	#Check buttons
	self.check1 = gtk.CheckButton(self.config.get('LanguageFile','75').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.check1.connect('toggled', self.ice_eye_togg)
	self.check2 = gtk.CheckButton(self.config.get('LanguageFile','76').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Radio buttons
	self.igno1 = gtk.RadioButton(None, self.config.get('LanguageFile','77').decode(locale.getpreferredencoding()).encode("utf-8"), False)
        self.igno2 = gtk.RadioButton(self.igno1, self.config.get('LanguageFile','78').decode(locale.getpreferredencoding()).encode("utf-8"), False)
	
	#Separators
	self.sep3 = gtk.HSeparator()
	
	#Labels
	self.info = gtk.Label(self.config.get('LanguageFile','79').decode(locale.getpreferredencoding()).encode("utf-8") + '\n')
	self.space = gtk.Label('\n')
	
	#Attach
	self.eyetable.attach(self.info ,0, 3, 0, 1, gtk.EXPAND|gtk.FILL, 0)
	self.eyetable.attach(self.check1 ,0, 3, 1, 2, gtk.FILL, 0)
	self.eyetable.attach(self.check2 ,0, 3, 2, 3, gtk.FILL, 0)
	self.eyetable.attach(self.space ,0, 3, 4, 5, gtk.FILL, 0)
	self.eyetable.attach(self.igno1 ,0, 3, 5, 6, gtk.FILL, 0)
	self.eyetable.attach(self.igno2 ,0, 3, 7, 8, gtk.FILL, 0)
	self.eyetable.attach(self.sep3 ,0, 3, 8, 9, gtk.FILL, 0)
	
	#Label box Ice Eye
	self.eyebox = gtk.HBox(False, 0)
	self.eyeimage = gtk.Image()
	self.eyeimage.set_from_file('Icons' + self.sysep + 'Ice_Eye.png')
	self.eyelab = gtk.Label(' Ice Eye')
	self.eyeimage.show()
	self.eyelab.show()
	self.eyebox.pack_start(self.eyeimage, True, 1)
	self.eyebox.pack_start(self.eyelab, False, 1)
	
	##Scan Log Section
	
	#Table
	self.scanlogtable = gtk.Table(3, 9, False)
	
	#Labels
	self.infos = gtk.Label(self.config.get('LanguageFile','80').decode(locale.getpreferredencoding()).encode("utf-8") + '\n')
	self.spaces = gtk.Label('\n')
	self.scanmax = gtk.Label(' ' + self.config.get('LanguageFile','81').decode(locale.getpreferredencoding()).encode("utf-8") + '   ')
	
	#CheckButtons
	self.wrlog = gtk.CheckButton(self.config.get('LanguageFile','82').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.wrlog.connect('toggled',self.scan_log_togg)
	self.wrdet = gtk.CheckButton(self.config.get('LanguageFile','83').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#HScale and adjustment
	self.logs = gtk.HScale(self.adj)
	self.logs.set_digits(0)
	
	#Separators
	self.sep5 = gtk.HSeparator()
	
	#Box Button Clear Log
	self.clearlbox = gtk.HBox(False, 0)
	self.clearlimage = gtk.Image()
	self.clearlimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'clearlog.png')
	self.clearllab = gtk.Label(' ' + self.config.get('LanguageFile','97').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.clearlbox.pack_start(self.clearlimage, False, 1)
	self.clearlbox.pack_start(self.clearllab, True, 1)
	self.clearlbut = gtk.Button()
	self.clearlbut.add(self.clearlbox)
	self.clearlbut.connect('clicked', self.clear_log)
	
	#Button box
	self.pppbox = gtk.HBox(False, 0)
	self.pppbox.pack_start(self.clearlbut, False, 1)
	
	#Attach
	self.scanlogtable.attach(self.infos ,0, 3, 0, 1, gtk.EXPAND|gtk.FILL, 0)
	self.scanlogtable.attach(self.wrlog ,0, 3, 1, 2, gtk.FILL|gtk.FILL, 0)
	self.scanlogtable.attach(self.wrdet ,0, 3, 2, 3, gtk.FILL|gtk.FILL, 0)
	self.scanlogtable.attach(self.spaces ,0, 3, 3, 4, gtk.FILL|gtk.FILL, 0)
	self.scanlogtable.attach(self.logs ,2, 3, 4, 5, gtk.EXPAND|gtk.FILL, 0)
	self.scanlogtable.attach(self.scanmax ,0, 2, 4, 5, gtk.FILL|gtk.FILL, 0)
	self.scanlogtable.attach(self.sep5 ,0, 3, 5, 6, gtk.EXPAND|gtk.FILL, 0)
	self.scanlogtable.attach(self.pppbox ,0, 3, 6, 7, gtk.EXPAND|gtk.FILL, 0)
	
	#Label box Scan Log
	self.scanlogbox = gtk.HBox(False, 0)
	self.scanlogimage = gtk.Image()
	self.scanlogimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'scanlog.png')
	self.scanloglab = gtk.Label(' Scan Log')
	self.scanlogimage.show()
	self.scanloglab.show()
	self.scanlogbox.pack_start(self.scanlogimage, True, 1)
	self.scanlogbox.pack_start(self.scanloglab, False, 1)
	
	#Append pages
	self.prnotebook.append_page(self.prtable, self.generalbox)
	self.prnotebook.append_page(self.eyetable, self.eyebox)
	self.prnotebook.append_page(self.scanlogtable, self.scanlogbox)
	
	#Buttons
	#Box Button Apply
	self.applybox = gtk.HBox(False, 0)
	self.applyimage = gtk.Image()
	self.applyimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'apply.png')
	self.applylab = gtk.Label('  ' + self.config.get('LanguageFile','25').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.applybox.pack_start(self.applyimage, False, 1)
	self.applybox.pack_start(self.applylab, True, 1)
	self.applybut = gtk.Button()
	self.applybut.add(self.applybox)
	self.applybut.connect('clicked', self.apply_func)
	self.applybut.connect('clicked', self.refresh)
	
	#Box Button Cancel
	self.cancbox = gtk.HBox(False, 0)
	self.cancimage = gtk.Image()
	self.cancimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	self.canclab = gtk.Label('  ' + self.config.get('LanguageFile','26').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.cancbox.pack_start(self.cancimage, False, 1)
	self.cancbox.pack_start(self.canclab, True, 1)
	self.cancbut = gtk.Button()
	self.cancbut.add(self.cancbox)
	self.cancbut.connect("clicked", self.refresh)
	self.cancbut.connect_object("clicked", gtk.Widget.destroy, self.prwin)
	
	#Button box
	self.ppbox = gtk.HBox(False, 0)
	self.ppbox.pack_start(self.applybut, False, 1)
	self.ppbox.pack_start(self.cancbut, False, 1)
	
	#Load firefox path
	self.spath = self.spath[0:len(self.spath)]
	
	#Load check button low
	self.sclow = self.sclow[0:len(self.sclow)]
	if self.sclow == 'True':
		self.sclow = True
	else:
		self.sclow = False
	
	#Load check button medium	
	self.scmed = self.scmed[0:len(self.scmed)]
	if self.scmed == 'True':
		self.scmed = True
	else:
		self.scmed = False
	
	#Load check button high
	self.schigh = self.schigh[0:len(self.schigh)]
	if self.schigh == 'True':
		self.schigh = True
	else:
		self.schigh = False
		
	#Load check button ice eye
	self.sciceye = self.sciceye[0:len(self.sciceye)]
	if self.sciceye == 'True':
		self.sciceye = True
	else:
		self.sciceye = False
		
	#Load check button advert
	self.scavv = self.scavv[0:len(self.scavv)]
	if self.scavv == 'True':
		self.scavv = True
	else:
		self.scavv = False
		
	#Load Radio buttons ignore
	self.cobjn = self.cobjn[0:len(self.cobjn)]
	if self.cobjn == 'True':
		self.cobjn = True
	else:
		self.cobjn = False
		
	self.ncobjn = self.ncobjn[0:len(self.ncobjn)]
	if self.ncobjn == 'True':
		self.ncobjn = True
	else:
		self.ncobjn = False
	
	#Load check button write
	self.scwrite = self.scwrite[0:len(self.scwrite)]
	if self.scwrite == 'True':
		self.scwrite = True
	else:
		self.scwrite = False
		
	#Load check button write details
	self.writedet = self.writedet[0:len(self.writedet)]
	if self.writedet == 'True':
		self.writedet = True
	else:
		self.writedet = False
        
	#Assign 
	self.fcentry.set_text(self.spath)
	self.ign1.set_active(self.sclow)
	self.ign2.set_active(self.scmed)
	self.ign3.set_active(self.schigh)
	self.check1.set_active(self.sciceye)
	self.check2.set_active(self.scavv)
	self.igno1.set_active(self.cobjn)
	self.igno2.set_active(self.ncobjn)
	self.wrlog.set_active(self.scwrite)
	self.wrdet.set_active(self.writedet)
	
	#Toggled
	toggled = self.check1.get_active()
	if toggled is False:
		self.check2.set_sensitive(False)
		self.igno1.set_sensitive(False)
		self.igno2.set_sensitive(False)
	else:
		self.check2.set_sensitive(True)
		self.igno1.set_sensitive(True)
		self.igno2.set_sensitive(True)
		
	toggled2 = self.wrlog.get_active()
	if toggled2 is False:
		self.wrdet.set_sensitive(False)
		self.logs.set_sensitive(False)
	else:
		self.wrdet.set_sensitive(True)
		self.logs.set_sensitive(True)
	
	#Attach
	self.maintable.attach(self.prnotebook ,0, 2, 0, 1, gtk.EXPAND|gtk.FILL, 0)
	self.maintable.attach(self.ppbox ,0, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
	
	
	self.prwin.add(self.maintable)
        self.prwin.show_all()
	
        
    def clear_log(self, widget):
	#Advert window content
	advlog = self.config.get('LanguageFile','84').decode(locale.getpreferredencoding()).encode("utf-8")
	
	#Advert window widget
	self.advlog = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, advlog)
	self.advlog.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.advlog.set_modal(True)
	self.advlog.set_transient_for(self.prwin)
	
	#Show message
	self.advlog.show()
        resp = self.advlog.run()
        if resp == gtk.RESPONSE_NO:
           self.advlog.destroy()
	   
        if resp == gtk.RESPONSE_YES:
           self.advlog.destroy()
	   datain = open('History' + self.sysep + 'log.txt', 'w')
 	   datain.flush()
           
           #Write eventlog
           self.write_ev('log')
	   
	   
	self.advlog.destroy()
	
    def ice_eye_togg(self, widget):
	toggled = self.check1.get_active()
	if toggled is False:
		self.check2.set_sensitive(False)
		self.igno1.set_sensitive(False)
		self.igno2.set_sensitive(False)
	else:
		self.check2.set_sensitive(True)
		self.igno1.set_sensitive(True)
		self.igno2.set_sensitive(True)
		
    def scan_log_togg(self, widget):
        toggled2 = self.wrlog.get_active()
	if toggled2 is False:
		self.wrdet.set_sensitive(False)
		self.logs.set_sensitive(False)
	else:
		self.wrdet.set_sensitive(True)
		self.logs.set_sensitive(True)
	
	
	
    def clean_text(self, widget):
        self.fcentry.set_text('')
	
    def refresh(self, widget):
	#Load configuration
	self.conf = ConfigParser.ConfigParser()
	self.conf.read("Data" + self.sysep + "nistin.dll")
		
	#Assign stats variables
	self.spath = str(self.conf.get('Config','cookie_path'))
	self.sclow = str(self.conf.get('Config','ignore_low'))
	self.scmed = str(self.conf.get('Config','ignore_med'))
	self.schigh = str(self.conf.get('Config','ignore_high'))
	self.sciceye = str(self.conf.get('Config','Ice_Eye'))
	self.scavv = str(self.conf.get('Config','Ice_Eye_Adv'))
	self.cobjn = str(self.conf.get('Config','Ice_Eye_ig'))
	self.ncobjn = str(self.conf.get('Config','Ice_Eye_nig'))
	self.scwrite = str(self.conf.get('Config','writelog'))
	self.writedet = str(self.conf.get('Config','wl_details'))
	self.maxlogs = str(self.conf.get('Config','max_logs'))
	self.lastupd = str(self.conf.get('Config','lastupd'))
	self.lang = str(self.conf.get('Config','language'))
	
	#Refresh index treeview
	self.liststore.set_value(self.liststore.get_iter(0),1, self.nscan)
	self.liststore.set_value(self.liststore.get_iter(1),1, self.nfound)
	self.liststore.set_value(self.liststore.get_iter(2),1, self.nrem)
	self.liststore.set_value(self.liststore.get_iter(3),1, self.npot)
	self.liststore.set_value(self.liststore.get_iter(4),1, self.nrhigh)
	self.liststore.set_value(self.liststore.get_iter(5),1, self.nrmed)
	self.liststore.set_value(self.liststore.get_iter(6),1, self.nrlow)
	
    def rewrite(self, widget):
	#Load configuration
	self.conf = ConfigParser.ConfigParser()
	self.conf.read("Data" + self.sysep + "nistin.dll")
		
	#Assign stats variables
	self.spath = str(self.conf.get('Config','cookie_path'))
	self.sclow = str(self.conf.get('Config','ignore_low'))
	self.scmed = str(self.conf.get('Config','ignore_med'))
	self.schigh = str(self.conf.get('Config','ignore_high'))
	self.sciceye = str(self.conf.get('Config','Ice_Eye'))
	self.scavv = str(self.conf.get('Config','Ice_Eye_Adv'))
	self.cobjn = str(self.conf.get('Config','Ice_Eye_ig'))
	self.ncobjn = str(self.conf.get('Config','Ice_Eye_nig'))
	self.scwrite = str(self.conf.get('Config','writelog'))
	self.writedet = str(self.conf.get('Config','wl_details'))
	self.maxlogs = str(self.conf.get('Config','max_logs'))
	if self.setupd is False:
	   self.lastupd = str(self.conf.get('Config','lastupd'))
	if self.setlang is False:
	   self.lang = str(self.conf.get('Config','language'))
	self.rw = ['[MainTable]\n', 'Scans:   ' + str(self.nscan) + '\n','Found:   ' + str(self.nfound) + '\n','Removed: ' + str(self.nrem) + '\n','PotM:    ' + str(self.npot) + '\n','RHigh:   ' + str(self.nrhigh) + '\n','RMed:    '+ str(self.nrmed) + '\n','RLow:    ' + str(self.nrlow) + '\n','\n[Config]\n','cookie_path: ' + self.spath + '\n','ignore_low:  ' + self.sclow  + '\n','ignore_med:  ' + self.scmed + '\n','ignore_high: ' + self.schigh + '\n','Ice_Eye:     ' + self.sciceye + '\n','Ice_Eye_Adv: ' + self.scavv + '\n','Ice_Eye_ig:  ' + self.cobjn + '\n','Ice_Eye_nig: ' + self.ncobjn + '\n','writelog:    ' + self.scwrite + '\n','wl_details:  ' + self.writedet + '\n','max_logs:    ' + self.maxlogs + '\n','lastupd:     ' + self.lastupd + '\n','language:    ' + self.lang + '\n']
	datain = open('Data' + self.sysep + 'nistin.dll', 'w')
	datain.writelines(self.rw)
	self.setlang = False
	self.setupd = False
	
    def change_ita(self, widget):
	#Check language
        self.refresh(self)
	lang = 'Italian' in self.lang
	if lang is False:
		self.langset = 'Italian'
		self.lang_func()
		
    def change_eng(self, widget):
	#Check language
        self.refresh(self)
	lang = 'English' in self.lang
	if lang is False:
		self.langset = 'English'
		self.lang_func()
		
		
    def change_du(self, widget):
	#Check language
        self.refresh(self)
	lang = 'Dutch' in self.lang
	if lang is False:
		self.langset = 'Dutch'
		self.lang_func()
		
    def change_sp(self, widget):
	#Check language
        self.refresh(self)
	lang = 'Spanish' in self.lang
	if lang is False:
		self.langset = 'Spanish'
		self.lang_func()
		
    def change_spar(self, widget):
	#Check language
        self.refresh(self)
	lang = 'SpAR' in self.lang
	if lang is False:
		self.langset = 'SpAR'
		self.lang_func()
		
    def change_cat(self, widget):
	#Check language
        self.refresh(self)
	lang = 'Catalan' in self.lang
	if lang is False:
		self.langset = 'Catalan'
		self.lang_func()
		
		
    def lang_func(self):
	self.advertl = self.config.get('LanguageFile','68').decode(locale.getpreferredencoding()).encode("utf-8")
	self.lange = gtk.MessageDialog(None, 0, gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, self.advertl)
	self.lange.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.lange.set_modal(True)
	self.lange.set_transient_for(self.win)
	self.lange.show()
	asw = self.lange.run()
	if asw == gtk.RESPONSE_YES:
	   self.lang = self.langset
	   self.setlang = True
	   self.rewrite(self)
           self.lange.destroy()
           self.win.destroy()
	if asw == gtk.RESPONSE_NO:
           self.lang = self.lang
	   self.rewrite(self)
	   self.lange.destroy()
	self.lange.destroy()
	
    def apply_func(self, widget):
        #Take entry values
	changed = 0
	self.spath = self.fcentry.get_text()
	self.sclow = self.ign1.get_active()
	self.sclow = str(self.sclow)
	self.scmed = self.ign2.get_active()
	self.scmed = str(self.scmed)
	self.schigh = self.ign3.get_active()
	self.schigh = str(self.schigh)
	self.sciceye = self.check1.get_active()
	self.sciceye = str(self.sciceye)
	self.scavv = self.check2.get_active()
	self.scavv = str(self.scavv)
	self.cobjn = self.igno1.get_active()
	self.cobjn = str(self.cobjn)
	self.ncobjn = self.igno2.get_active()
	self.ncobjn = str(self.ncobjn)
	self.scwrite = self.wrlog.get_active()
	self.scwrite = str(self.scwrite)
	
	if self.writedet != self.wrdet.get_active():
	   changed = 1
	self.writedet = self.wrdet.get_active()
	self.writedet = str(self.writedet)
	
	if float(self.maxlogs) != self.adj.get_value():
	    changed = 1
	self.maxlogs = self.adj.get_value()
	self.maxlogs = str(self.maxlogs)
	
	if changed == 1:
		#Advert
		advch = self.config.get('LanguageFile','85').decode(locale.getpreferredencoding()).encode("utf-8")
	        self.advch = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, advch)
	        self.advch.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
	        self.advch.set_modal(True)
	        self.advch.set_transient_for(self.prwin)
	   
	        #Show message
	        self.advch.show()
                resp = self.advch.run()
                if resp == gtk.RESPONSE_NO:
                   data = open('History' + self.sysep + 'log.txt', 'w')
 	           data.flush()
		   self.advch.destroy()
	   
                if resp == gtk.RESPONSE_YES:
		   data = open('History' + self.sysep + 'log.txt', 'r')
		   loglines = data.readlines()
		   bk = open('History' + self.sysep + 'logbk.txt', 'w')
		   bk.writelines(loglines)
                   data = open('History' + self.sysep + 'log.txt', 'w')
 	           data.flush()
		   self.advch.destroy()
	        self.advch.destroy()
		

	#Rewrite configuration file
	datain = open('Data' + self.sysep + 'nistin.dll', 'w')
	datain.flush()
	self.rw = ['[MainTable]\n', 'Scans:   ' + str(self.nscan) + '\n','Found:   ' + str(self.nfound) + '\n','Removed: ' + str(self.nrem) + '\n','PotM:    ' + str(self.npot) + '\n','RHigh:   ' + str(self.nrhigh) + '\n','RMed:    '+ str(self.nrmed) + '\n','RLow:    ' + str(self.nrlow) + '\n','\n[Config]\n','cookie_path: ' + self.spath + '\n','ignore_low:  ' + self.sclow  + '\n','ignore_med:  ' + self.scmed + '\n','ignore_high: ' + self.schigh + '\n','Ice_Eye:     ' + self.sciceye + '\n','Ice_Eye_Adv: ' + self.scavv + '\n','Ice_Eye_ig:  ' + self.cobjn + '\n','Ice_Eye_nig: ' + self.ncobjn + '\n','writelog:    ' + self.scwrite + '\n','wl_details:  ' + self.writedet + '\n','max_logs:    ' + self.maxlogs + '\n','lastupd:     ' + self.lastupd + '\n','language:    ' + self.lang + '\n']
	datain.writelines(self.rw)
	self.prwin.destroy()

    def browser(self, widget):
	#File chooser
        self.filebrowser = gtk.FileChooserDialog(self.config.get('LanguageFile','34').decode(locale.getpreferredencoding()).encode("utf-8"), None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
	self.filebrowser.set_transient_for(self.prwin)
	self.filebrowser.set_modal(True)
	self.filebrowser.set_show_hidden(True)
	self.filter = gtk.FileFilter()
        self.filter.add_pattern("*")
        self.filebrowser.add_filter(self.filter)
	response = self.filebrowser.run()
        filesel = self.filebrowser.get_filename()
        if response == gtk.RESPONSE_ACCEPT:
            filesel = self.filebrowser.get_filename()
	    self.fcentry.set_text(filesel)
	if response == gtk.RESPONSE_REJECT:
	    pass
	self.filebrowser.destroy()
	
    def winscan(self, widget):
	#Window
	self.winsc = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.winsc.connect("delete_event", self.finishscan)
	self.winsc.set_position(gtk.WIN_POS_CENTER)
	if 'True' in self.sciceye:
		self.winsc.set_default_size(491, 270)
	else:
		self.winsc.set_default_size(491, 250)
        self.winsc.set_resizable(True)
        self.winsc.set_title(self.config.get('LanguageFile','35').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.winsc.set_modal(True)
	self.winsc.set_transient_for(self.win)
	
	#Initial vars
	self.objf = 0
	self.objc = 0
	self.objh = 0
	self.objm = 0
	self.objl = 0
	self.obji = 0
	self.objp = 0
	self.cc = 0
	self.cc = str(self.cc)
	self.minerf = False
	self.riskf = False
	self.scanex = False
	
	
	#Initial log vars
	self.foundlog = 0
	self.removelog = 0
	self.checklog = 0
	self.lowlog = 0
	self.highlog = 0
	self.medlog = 0
	self.ignorelog = 0
	self.risklog = 0
	self.totallog = 0
	
	#Initial vars
	#Initial
	self.defound = '0' * int(self.dbt)
	self.decheck = '0' * int(self.dbt)
	self.deline = ''
	self.potnums = 0
	self.pocheck = ''
		
        #Secondary vars
	self.minerf = False
	
	#Table
	self.statable = gtk.Table(6, 3, False)
	
	#Separators
	self.hsep = gtk.HSeparator()
	self.hsep2 = gtk.HSeparator()
	
	#Progress bar
	self.bar1 = gtk.ProgressBar()
	self.bar1.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
	self.bar1.set_fraction(0.0)
	
	#Label 
	self.progresslab = gtk.Label( self.config.get('LanguageFile','36').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' + self.cc)
	
	#Box Button Close
	self.closebox = gtk.HBox(False, 0)
	self.closeimage = gtk.Image()
	self.closeimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	self.closelab = gtk.Label('  ' + self.config.get('LanguageFile','37').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.closebox.pack_start(self.closeimage, False, 1)
	self.closebox.pack_start(self.closelab, True, 1)
	self.closebut = gtk.Button()
	self.closebut.add(self.closebox)
	self.closebut.connect_object("clicked", gtk.Widget.destroy, self.winsc)
	self.closebut.connect('clicked', self.refresh)
	
	#Box Button Scan
	self.scansbox = gtk.HBox(False, 0)
	self.scansimage = gtk.Image()
	self.scansimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'start_scan.png')
	self.scanslab = gtk.Label(' ' + self.config.get('LanguageFile','38').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.scansbox.pack_start(self.scansimage, False, 1)
	self.scansbox.pack_start(self.scanslab, True, 1)
	self.scansbut = gtk.Button()
	self.scansbut.add(self.scansbox)
	self.scansbut.connect('clicked', self.scansion)
	
	#Box Button Finish
	self.finbox = gtk.HBox(False, 0)
	self.finimage = gtk.Image()
	self.finimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'finish.png')
	self.finlab = gtk.Label(' ' + self.config.get('LanguageFile','39').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.finbox.pack_start(self.finimage, False, 1)
	self.finbox.pack_start(self.finlab, True, 1)
	self.finbut = gtk.Button()
	self.finbut.add(self.finbox)
	self.finbut.set_sensitive(False)
	self.finbut.connect('clicked', self.finish)
	
	#Box Button Remove
	self.rmbox = gtk.HBox(False, 0)
	self.rmimage = gtk.Image()
	self.rmimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'rmtool.png')
	self.rmlab = gtk.Label(' ' +self.config.get('LanguageFile','40').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.rmbox.pack_start(self.rmimage, False, 1)
	self.rmbox.pack_start(self.rmlab, True, 1)
	self.rmbut = gtk.Button()
	self.rmbut.add(self.rmbox)
	self.rmbut.set_sensitive(False)
	self.rmbut.connect('clicked', self.removetool)
	
	
	#Button box
	self.bpbox = gtk.HBox(False, 0)
	self.bpbox.pack_start(self.closebut, False, 1)
	self.bpbox.pack_start(self.scansbut, False, 1)
	
	#Button box
	self.bpbox2 = gtk.HBox(False, 0)
	self.bpbox2.pack_start(self.finbut, False, 1)
	self.bpbox2.pack_start(self.rmbut, False, 1)
	
	#Add Pixbuf
	dmfind_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "dmfind.png")
	dmchecked_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "ocheck.png")
	dmhigh_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "dmhigh.png")
	dmmed_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "dmmed.png")
	dmlow_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "dmlow.png")
	dmpot_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "dmpot.png")
	dmignored_im = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "ignored.png")
	
	#ListStore
        self.statstore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
        self.statstore.append([dmfind_im ,self.objf, self.config.get('LanguageFile','41').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.statstore.append([dmchecked_im ,self.objc, self.config.get('LanguageFile','42').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.statstore.append([dmhigh_im ,self.objh, self.config.get('LanguageFile','43').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.statstore.append([dmmed_im ,self.objm, self.config.get('LanguageFile','44').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.statstore.append([dmlow_im ,self.objl, self.config.get('LanguageFile','45').decode(locale.getpreferredencoding()).encode("utf-8")])
	if 'True' in self.sciceye:
		self.statstore.append([dmpot_im ,self.objp, self.config.get('LanguageFile','86').decode(locale.getpreferredencoding()).encode("utf-8")])
	self.statstore.append([dmignored_im ,self.obji, self.config.get('LanguageFile','46').decode(locale.getpreferredencoding()).encode("utf-8")])
	
	#TreeView
	self.statview = gtk.TreeView(self.statstore)
	self.statview.set_rules_hint(True)
	self.statview.set_headers_clickable(False)
	
	
	#TreeViewColums
	self.columnum = gtk.TreeViewColumn('            ')
	self.columnum.set_resizable(True)
	self.columndet = gtk.TreeViewColumn(self.config.get('LanguageFile','47').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Append columns
	self.statview.append_column(self.columnum)
	self.statview.append_column(self.columndet)
	
	#Cellrenderers2
	self.cellimg = gtk.CellRendererPixbuf()
	self.cellnum = gtk.CellRendererText()
	self.celldet = gtk.CellRendererText()
	
	#add cell renderers
	self.columnum.pack_start(self.cellimg, True)
	self.columnum.pack_start(self.cellnum, True)
	self.columndet.pack_start(self.celldet, True)
	
	#set attributes
	self.columnum.set_attributes(self.cellimg, pixbuf=0)
	self.columnum.set_attributes(self.cellnum, text=1)
	self.columndet.set_attributes(self.celldet, text=2)
	self.cellimg.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
	
	#Show 
	self.statable.attach(self.statview, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	self.statable.attach(self.progresslab, 1, 3, 1, 2, gtk.FILL, gtk.FILL)
	self.statable.attach(self.bar1, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
        self.statable.attach(self.bpbox, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
	self.statable.attach(self.hsep, 0, 3, 2, 3, gtk.FILL, 0)
	self.statable.attach(self.bpbox2, 2, 3, 3, 4, gtk.FILL, gtk.FILL)
	self.statable.attach(self.hsep2, 0, 3, 4, 5, gtk.FILL, 0)
        self.winsc.add(self.statable)
	self.winsc.show_all()
	
	#Focus
	self.winsc.set_focus(None)
	
    def progress_timeout(self, widget):
	self.updbar.pulse()
	return True
	
    def progress_start(self, widget):
	#Start progress
	self.timer = gobject.timeout_add (50, self.progress_timeout, self)
	self.pro = True
	
    def destroy_progress(self, widget, data=None):
	if self.pro:
           gobject.source_remove(self.timer)
	   self.pro = False
	else:
           pass
	  
    def nvupdates(self, widget):
	self.data = self.data.split('\r\n\r\n')
	currd = self.data[1].split('\n')
	currdb = currd[1]
	currdb = currdb[7:len(currdb)-1]
	currdb = int(currdb)
	currdv = currd[2]
	currdv = currdv[5:len(currdv)-1]
	currdv = str(currdv)
        now = time.time()
        timedate = time.localtime(now)
        year = timedate[0]
        month = timedate[1]
        day = timedate[2]
        self.lastupd = str(day) + '/' + str(month) + '/' + str(year)
        self.rewrite(self)
        self.refresh_updl(self)
	if currdb <= int(self.dbnum):
	   self.connectbut.set_sensitive(True)
	   self.avup = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','122').decode(locale.getpreferredencoding()).encode("utf-8"))
	   self.avup.set_title('Server')
	   self.avup.set_modal(True)
	   self.avup.set_transient_for(self.updwin)
	   self.avup.show()
	   self.refresh_updl(self)
	   resp = self.avup.run()
           if resp == gtk.RESPONSE_CLOSE:
              self.avup.destroy()
           self.avup.destroy()
	if currdb > int(self.dbnum):
           self.connectbut.set_sensitive(True)
	   self.disp = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, self.config.get('LanguageFile','123').decode(locale.getpreferredencoding()).encode("utf-8") + '\n'  + self.config.get('LanguageFile','104').decode(locale.getpreferredencoding()).encode("utf-8")+ ': ' + currdv + '\n___\n' + self.config.get('LanguageFile','124').decode(locale.getpreferredencoding()).encode("utf-8"))
	   self.disp.set_title('Server')
	   self.disp.set_modal(True)
	   self.disp.set_transient_for(self.updwin)
	   self.disp.show()
	   resp = self.disp.run()
           if resp == gtk.RESPONSE_YES:
	      self.updbars.push(1, self.config.get('LanguageFile','118').decode(locale.getpreferredencoding()).encode("utf-8"))
	      self.dbcontent = self.data[1:len(self.data)]
	      s = open('Data' + self.sysep + 'ndefx.dll','w')
	      s.flush()
	      s.writelines(self.dbcontent)
	      s.close()
	      self.updbars.push(1, self.config.get('LanguageFile','119').decode(locale.getpreferredencoding()).encode("utf-8"))
	      self.db_update(self)
	      self.rewrite(self)
	      self.refresh_updl(self)
	      self.updbars.push(1, self.config.get('LanguageFile','120').decode(locale.getpreferredencoding()).encode("utf-8"))
              self.disp.destroy()
              
              #Write eventlog
              self.write_ev('upd_s')
	   if resp == gtk.RESPONSE_NO:
              self.rewrite(self)
              self.refresh_updl(self)
              self.disp.destroy()
           self.disp.destroy()
	   
    def refresh_updl(self, widget):
	#Update db list
	self.dbstore.set_value(self.dbstore.get_iter(0),2, self.dbv)
	self.dbstore.set_value(self.dbstore.get_iter(1),2, self.dbds)
        self.dbstore.set_value(self.dbstore.get_iter(2),2, self.dbid)
	self.dbstore.set_value(self.dbstore.get_iter(3),2, 'nixory.sourceforge.net')
	self.dbstore.set_value(self.dbstore.get_iter(4),2, self.lastupd)
	self.dbbar.push(1, ':::Database version ' + self.dbv + ' (' + self.dbd + ')')
	
    def refresh_upd(self, widget):
	#Update last connection
	self.dbstore.set_value(self.dbstore.get_iter(4),2, self.lastupd)
	   
    def db_update(self, widget):
	#Load Definitions database
	self.LocDatabase = {}
	self.LinkDatabase = {}
	self.database = ConfigParser.ConfigParser()
	self.database.read("Data" + self.sysep + "ndefx.dll")
        self.dbtot = self.database.get('Definitions','nt')
	self.dbt = self.database.get('Definitions','cp')
	self.dbv = self.database.get('Definitions','dbv')
	self.dbd = self.database.get('Definitions','dbd')
	self.dbds = self.database.get('Definitions','dbds')
	self.dbid = self.database.get('Definitions','dbid')
	self.dbnum = self.database.get('Definitions','dbnum')
	self.sepjk = self.database.get('Definitions','sep')
	i = 1
	m = 1
	while i <= int(self.dbtot):
		dbname = self.database.get('Definitions', str(i))
		self.LocDatabase[dbname] = {}
		db = {}
		n = self.database.get('Definitions','nt' + str(i))
		b = 1
		while b <= int(n):
			self.LinkDatabase['dm' + str(m)] = self.database.get('Definitions','dm' + str(m)).split(self.sepjk)
			db[self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '1')] = [self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '2'), self.database.get('Definitions',str(i) + 'x' + str(b) + 'x' + '3')]
			b = b + 1
			m = m + 1
		self.LocDatabase[dbname] = db
		i = i + 1
	    
    def timeout(self, widget):
        #Write Eventlog
        self.write_ev('upd_f')
        
	self.updbars.push(1, self.config.get('LanguageFile','121').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.destroy_progress(self, '')
	self.connectbut.set_sensitive(True)
	self.timerr = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','125').decode(locale.getpreferredencoding()).encode("utf-8") + '\n ' + self.config.get('LanguageFile','126').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.timerr.set_title('Error')
	self.timerr.set_modal(True)
	self.timerr.set_transient_for(self.updwin)
	self.timerr.show()
	resp = self.timerr.run()
        if resp == gtk.RESPONSE_CLOSE:
           self.timerr.destroy()
        self.timerr.destroy()
	   
    def socket_conn(self, widget):
	#Starting connection
	self.connectbut.set_sensitive(False)
	self.updbars.push(1, self.config.get('LanguageFile','113').decode(locale.getpreferredencoding()).encode("utf-8"))
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.s.setblocking(0)
        try:
           self.s.connect(('nixory.sourceforge.net',80))
	except socket.gaierror:
	   self.updbars.push(1, self.config.get('LanguageFile','114').decode(locale.getpreferredencoding()).encode("utf-8"))
	   self.destroy_progress(self, '')
	   self.connectbut.set_sensitive(True)
          
           #Write Eventlog
           self.write_ev('upd_f')
           
	   self.gaierr = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','127').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','126').decode(locale.getpreferredencoding()).encode("utf-8"))
	   self.gaierr.set_title('Error')
	   self.gaierr.set_modal(True)
	   self.gaierr.set_transient_for(self.updwin)
	   self.gaierr.show()
	   resp = self.gaierr.run()
           if resp == gtk.RESPONSE_CLOSE:
              self.gaierr.destroy()
           self.gaierr.destroy()
        except socket.error:
	   self.connstate = 0
	   self.data = ''
	   self.cnnd = False
	   self.times = time.clock()
           gobject.idle_add(self.select_eco)
	   
	   
    def select_eco(self):
      if self.connf == 0:
	readyr, readyw, readye = select.select([self.s], [self.s], [self.s], 0)
	select.select([self.s], [self.s], [self.s], 0)
	if self.connstate == 0:
           if self.s in readyw:
		self.connstate = 1
		self.updbars.push(1, self.config.get('LanguageFile','115').decode(locale.getpreferredencoding()).encode("utf-8"))
		self.s.send('GET /database/database.def HTTP/1.1\r\nHost: nixory.sourceforge.net\r\n\r\n')
	   else:
		self.timee = time.clock()
		if (self.timee - self.times) > 100:
	           self.timeout(self)
		   self.s.close()
		   return False
	if self.connstate == 1:
	   if self.s in readyr:
		if self.cnnd is False:
		   self.updbars.push(1, self.config.get('LanguageFile','116').decode(locale.getpreferredencoding()).encode("utf-8"))
		   self.cnnd = True
		reciv = self.s.recv(3)
		self.data = self.data + reciv
		if len(reciv) == 0:
		   connstate = 2
		   self.updbars.push(1, self.config.get('LanguageFile','117').decode(locale.getpreferredencoding()).encode("utf-8"))
		   self.destroy_progress(self, '')
		   self.nvupdates(self)
		   self.s.close()
		   return False
        if self.connstate != 2:
	   return True
      else:
	   self.s.close()
	   return False
	   
    def dialog_t(self, widget):
	self.nixoryicth.add(gtk.STOCK_DIALOG_INFO, self.info_stockset)
	self.connf = 1
	
    def dialog_tb(self, widget, data=None):
	self.nixoryicth.add(gtk.STOCK_DIALOG_INFO, self.info_stockset)
	self.connf = 1

    def update_win(self, widget):
        #Update Window
	self.updwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.updwin.connect("delete_event", self.destroy_progress)
	self.updwin.connect("delete_event", self.dialog_tb)
        self.updwin.connect("delete_event", self.delete_event)
	self.updwin.set_position(gtk.WIN_POS_CENTER)
	self.updwin.set_default_size(390, 228)
        self.updwin.set_resizable(True)
        self.updwin.set_title(self.config.get('LanguageFile','110').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.updwin.set_modal(True)
	self.updwin.set_transient_for(self.win)
	self.pro = False
	
	#Dialog
	self.nixoryicth.add(gtk.STOCK_DIALOG_INFO, self.net_stockset)
	self.connf = 0
	
	#Table
	self.updtable = gtk.Table(9, 9, False)

	#ListStore
        self.dbstore = gtk.ListStore(gtk.gdk.Pixbuf, str, str)
	
	#Pixbuf Items
	dmver = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'database.png')
	dmdat = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'database_date.png')
	dmid = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'database_id.png')
	server = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'server.png')
	lastdm = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'connect_to_network.png')
	
	#Append
	self.dbstore.append([dmver, self.config.get('LanguageFile','104').decode(locale.getpreferredencoding()).encode("utf-8"), self.dbv])
	self.dbstore.append([dmdat, self.config.get('LanguageFile','105').decode(locale.getpreferredencoding()).encode("utf-8"), self.dbds])
	self.dbstore.append([dmid, self.config.get('LanguageFile','106').decode(locale.getpreferredencoding()).encode("utf-8"), self.dbid])
	self.dbstore.append([server, self.config.get('LanguageFile','107').decode(locale.getpreferredencoding()).encode("utf-8"), 'nixory.sourceforge.net'])
        self.dbstore.append([lastdm, self.config.get('LanguageFile','108').decode(locale.getpreferredencoding()).encode("utf-8"), self.lastupd])
	
	
	#TreeView
	self.dbview = gtk.TreeView(self.dbstore)
	self.dbview.set_rules_hint(True)
	
	#TreeViewColums
	self.dbcolumn1 = gtk.TreeViewColumn('          ')
	self.dbcolumn1.set_resizable(True)
	self.dbcolumn2 = gtk.TreeViewColumn('                                              ')
	self.dbcolumn2.set_resizable(True)
	self.dbcolumn3 = gtk.TreeViewColumn('                                               ')
	self.dbcolumn3.set_resizable(True)
	
	#Append columns
	self.dbview.append_column(self.dbcolumn1)
	self.dbview.append_column(self.dbcolumn2)
	self.dbview.append_column(self.dbcolumn3)
	
	#Cellrenderers2
	self.dbcell1 = gtk.CellRendererPixbuf()
	self.dbcell2 = gtk.CellRendererText()
	self.dbcell3 = gtk.CellRendererText()
	
	#add cell renderers
	self.dbcolumn1.pack_start(self.dbcell1, True)
	self.dbcolumn2.pack_start(self.dbcell2, True)
	self.dbcolumn3.pack_start(self.dbcell3, True)
	
	#set attributes
	self.dbcolumn1.set_attributes(self.dbcell1, pixbuf=0)
	self.dbcolumn2.set_attributes(self.dbcell2, text=1)
	self.dbcolumn3.set_attributes(self.dbcell3, text=2)
	
	#Progress Bar
	self.updbar = gtk.ProgressBar()
	self.updbar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
	self.updbar.pulse()
	self.updbar.set_pulse_step(0.05)
	
	#Box Button Connect
	self.connectbox = gtk.HBox(False, 0)
	self.connectimage = gtk.Image()
	self.connectimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'connect.png')
	self.connectlab = gtk.Label('  ' + self.config.get('LanguageFile','111').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.connectbox.pack_start(self.connectimage, False, 1)
	self.connectbox.pack_start(self.connectlab, True, 1)
	self.connectbut = gtk.Button()
	self.connectbut.add(self.connectbox)
	self.connectbut.connect("clicked", self.progress_start)
        self.connectbut.connect("clicked", self.socket_conn)
	
	#Box Button Close
	self.closebox03 = gtk.HBox(False, 0)
	self.closeimage03 = gtk.Image()
	self.closeimage03.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	self.closelab03 = gtk.Label('  ' + self.config.get('LanguageFile','37').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.closebox03.pack_start(self.closeimage03, False, 1)
	self.closebox03.pack_start(self.closelab03, True, 1)
	self.closebut03= gtk.Button()
	self.closebut03.add(self.closebox03)
	self.closebut03.connect("clicked", self.destroy_progress)
	self.closebut03.connect("clicked", self.dialog_t)
	self.closebut03.connect_object("clicked", gtk.Widget.destroy, self.updwin)
	
	#HBox
	self.updbbox = gtk.HBox()
	self.updbbox.pack_start(self.closebut03, True, True)
	self.updbbox.pack_start(self.connectbut, True, True)
	
	#StatusBar
	self.updbars = gtk.Statusbar()
	self.updbars.push(1, self.config.get('LanguageFile','112').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Attach
	self.updtable.attach(self.dbview, 0, 9, 0, 4, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	self.updtable.attach(self.updbbox, 0, 2, 4, 6, 0, 0)
	self.updtable.attach(self.updbar, 4, 7, 4, 6, gtk.EXPAND|gtk.FILL , 0)
	self.updtable.attach(self.updbars, 0, 9, 6, 8, gtk.EXPAND|gtk.FILL , 0)
	self.updwin.add(self.updtable)
	self.updwin.show_all()
	

    def scansion(self, widget):
	start = time.clock()
	#Refresh vars
	self.refresh(self)
	spathlen = len(self.spath)
	self.spath = self.spath[0:spathlen]
	self.spath = unicode(self.spath)
	self.spath = self.spath.encode(locale.getpreferredencoding())
	
	#Check if is a file
	pathconf = os.path.isfile(self.spath)
	
	#Dialog errors
	self.error1 = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','48').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.error1.set_modal(True)
	self.error1.set_transient_for(self.winsc)
	
	self.error2 = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','49').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.error2.set_modal(True)
	self.error2.set_transient_for(self.winsc)
	
	#Open indicated file if it isn't 'None'
	if pathconf is True:
	    #read cookie file
	    cookietxt = open(self.spath, 'r')
	    self.cookiecon = cookietxt.readlines()
	    #verify valid cookie file
	    if len(self.cookiecon) != 0:
		if self.cookiecon[0] == '# HTTP Cookie File\n':
		   self.scanex = True
		   txtlen = len(self.cookiecon)
		   self.txtlen = len(str(txtlen))
		   self.delines = '0' * (self.txtlen * int(self.dbt))
		   
		   #Disable buttons
	           self.closebut.set_sensitive(False)
	           self.scansbut.set_sensitive(False)
		   
		   #Start scan
		   self.cookiex = 5
		   self.cookietot = len(self.cookiecon) - 1
		   self.curline = 1
		   self.potnums = 0
		   potconfv = 0
		   icc = 1
		   
		   #If there are no cookies
		   if self.cookietot == 4:
		     self.bar1.set_fraction(1.00)
		     self.bar1.set_text('100%')
		   
		   
		   #Scan cicle
		   while self.cookiex <= self.cookietot:
			 self.current = self.cookiecon[self.cookiex]
			 self.current = self.current.split('\t')
			 x = self.current[0]
			 self.curline = 1
			 foung = True
			 if self.LocDatabase.has_key(x):
				 dbn = self.LocDatabase[x]
			         if dbn.has_key(self.current[5]):
							 foung = False
							 dbf = dbn[self.current[5]]
							 if dbf[1] == '1':
								 self.sc = self.sclow
						         if dbf[1] == '2':
								 self.sc = self.scmed
						         if dbf[1] == '3':
								 self.sc = self.schigh
							
						         if self.sc == 'True':
								 self.obji = self.obji + 1
				                                 self.ignorelog = self.ignorelog + 1
						         else:
                                                                 self.defound = self.defound[0:int(dbf[0]) - 1] + '1' + self.defound[int(dbf[0]):len(self.defound)]
				                                 cookiexlen = str(self.cookiex)
			                                         cookiexlen = len(cookiexlen)
				                                 self.delines = self.delines[0 : self.txtlen * (int(dbf[0]) - 1)] + ('0' * (self.txtlen - cookiexlen)) + str(self.cookiex) + self.delines[self.txtlen * int(dbf[0]): len(self.delines)]
								 
								 #Refresh vars
			                                         self.objf = self.objf + 1
				                                 self.foundlog = self.foundlog + 1
				                                 self.minerf = True
								 
								 if dbf[1] == '1':
			                                            self.objl = self.objl + 1
						                 if dbf[1] == '2':
			                                            self.objm = self.objm + 1
						                 if dbf[1] == '3':
			                                            self.objh = self.objh + 1
					 
			 if foung is True:
				           if 'True' in self.sciceye:
						     if self.LocDatabase.has_key(self.current[0]):
						        if 'True' in self.cobjn:
							  self.obji = self.obji + 1
				                          self.ignorelog = self.ignorelog + 1
							else:
						         #Risk cookie
							 self.potnums = self.potnums + 1
							 self.objp = self.objp + 1
							 
							 #Refresh vars
			                                 self.objf = self.objf + 1
				                         self.foundlog = self.foundlog + 1
				                         self.minerf = True
							 self.riskf = True
							 
							 #Write file
							 if potconfv == 0:
								 potconf = open('Data' + self.sysep + 'potconf.dll','w')
								 wrlines = ['[PotConf]\n',str(icc) + ': ' +  str(self.current[0]) + '\n',str(icc + 1) + ': ' + str(self.current[5]) + '\n',str(icc + 2) + ': ' + str(self.cookiex) + '\n']
								 potconf.writelines(wrlines)
								 potconf.close()
								 potconfv = 1
							 else:
								 potconf = open('Data' + self.sysep + 'potconf.dll','a')
								 wrlines = [str(icc) + ': ' +  str(self.current[0]) + '\n',str(icc + 1) + ': ' + str(self.current[5]) + '\n',str(icc + 2) + ': ' + str(self.cookiex) + '\n']
								 potconf.writelines(wrlines)
								 potconf.close()
							 
							 icc = icc + 3
								    
	                                                                                   			 
				 
			 #Refresh list
			 self.refreshl()
			 self.cookiex = self.cookiex + 1
			 while gtk.events_pending():
                           gtk.main_iteration(False)			 
		   	 
	           #Vars
		   end = time.clock()
		   self.tot = end - start
		   self.pocheck = '0' * self.potnums
		   self.richeck = '0' * self.potnums
                   
		   
		   #Set buttons
		   if self.minerf is True:
			   self.closebut.set_sensitive(False)
			   self.scansbut.set_sensitive(False)
			   self.finbut.set_sensitive(True)
			   self.rmbut.set_sensitive(True)
		   else:
			   self.closebut.set_sensitive(False)
			   self.scansbut.set_sensitive(False)
			   self.finbut.set_sensitive(True)
			   self.rmbut.set_sensitive(False)
                   
                   #Write event log
                   self.write_ev('sc_s')
			 
			
		else:
	           self.scansbut.set_sensitive(False)
	           self.error2.show()
		   resp = self.error2.run()
                   if resp == gtk.RESPONSE_CLOSE:
                      self.error2.destroy()
		   self.error2.destroy()
                   
                   #Write event log
                   self.write_ev('sc_f')
		
            else:
	           self.scansbut.set_sensitive(False)
	           self.error2.show()
		   resp = self.error2.run()
                   if resp == gtk.RESPONSE_CLOSE:
                      self.error2.destroy()
		   self.error2.destroy()
                   
                   #Write event log
                   self.write_ev('sc_f')     
		
	else:
		self.scansbut.set_sensitive(False)
		self.error1.show()
		resp = self.error1.run()
                if resp == gtk.RESPONSE_CLOSE:
                      self.error1.destroy()
		self.error1.destroy()
                
                #Write event log
                self.write_ev('sc_f')
                
                
    def refreshl(self):
	     #progress bar
	     cookiexD = float(self.cookiex)
	     cookiexD = cookiexD - 4
	     cookietotD = float(self.cookietot)
	     cookietotD = cookietotD - 4
	     atr = cookiexD / cookietotD
	     atr = str(atr)
	     atr = atr[0:4]
	     atr = float(atr)
	     self.bar1.set_fraction(atr)
	     
	     #progress bar text
	     atrstr = str(atr)
	     if (atrstr[0:1] == '1'):
		     atrstr = '100%'
	     else:
		     atrstr = atrstr[2:4] 
		     if (len(atrstr) == 1):
		            atrstr = atrstr + '0'
		     atrstr = atrstr + '%'
	     self.bar1.set_text(atrstr)
	     
	     #progress label
	     self.cc = int(self.cc)
	     self.cc = self.cookiex - 4
	     self.objc = self.cc
	     self.cc = str(self.cc)
	     self.progresslab.set_text(self.config.get('LanguageFile','36').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' + str(self.cc))
	     
	    #Statstore
	     self.statstore.set_value(self.statstore.get_iter(0),1, self.objf)
	     self.statstore.set_value(self.statstore.get_iter(1),1, self.objc)
	     self.statstore.set_value(self.statstore.get_iter(2),1, self.objh)
	     self.statstore.set_value(self.statstore.get_iter(3),1, self.objm)
	     self.statstore.set_value(self.statstore.get_iter(4),1, self.objl)
	     if 'True' in self.sciceye:
		     self.statstore.set_value(self.statstore.get_iter(5),1, self.objp)
	             self.statstore.set_value(self.statstore.get_iter(6),1, self.obji)
             else:
		     self.statstore.set_value(self.statstore.get_iter(5),1, self.obji)

    def finish(self, widget, data=None):
	    #Others Dialog
	    self.confirm = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_YES_NO, self.config.get('LanguageFile','50').decode(locale.getpreferredencoding()).encode("utf-8"))
	    self.confirm.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
	    self.confirm.set_modal(True)
	    self.confirm.set_transient_for(self.winsc)
	    if self.minerf is True:
		    self.confirm.show()
		    resp = self.confirm.run()
                    if resp == gtk.RESPONSE_YES:
		       self.nscan = self.nscan + 1
		       
		       #Count found
		       self.nfound = self.nfound + int(self.defound.count('1')) + self.potnums
		       self.rewrite(self)
		       self.refresh(self)
                       self.confirm.destroy()
		       self.winsc.destroy()
		       
		       #Write log
	               self.checklog = self.objc
	               if 'True' in self.scwrite:
		          self.write_log(self)
		       if resp == gtk.RESPONSE_NO:
		        self.winsc.show()
                        self.confirm.destroy()
			
		        #Clear PotConf
			potfile = open('Data' + self.sysep + 'potconf.dll','w')
			potfile.flush()
			potfile.close()
			
		    self.confirm.destroy()
	    else:
		    self.nscan = self.nscan + 1
		    self.rewrite(self.rewrite)
		    self.refresh(self.refresh)
		    self.winsc.destroy()
		    
		    #Write log
	            self.checklog = self.objc
	            if 'True' in self.scwrite:
		       self.write_log(self)
		       
		    #Clear PotConf
		    potfile = open('Data' + self.sysep + 'potconf.dll','w')
		    potfile.flush()
		    potfile.close()
		    
    def finishscan(self, widget, data=None):
	    #If Scan has been executed
            if self.scanex:
	       self.nscan = self.nscan + 1
	       
	       #Count found
               self.nfound = self.nfound + int(self.defound.count('1')) + self.potnums
	       self.rewrite(self)
	       self.refresh(self)
               
            self.winsc.destroy()
            
	    if self.scanex:
	       #Write log
	       self.checklog = self.objc
	       if 'True' in self.scwrite:
		  self.write_log(self)
		  
               #Clear PotConf
	       potfile = open('Data' + self.sysep + 'potconf.dll','w')
	       potfile.flush()
	       potfile.close()
		  
    def removetool(self, widget):
	#Window
	self.winrm = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.winrm.connect("delete_event", self.rmchecked)
        self.winrm.connect("delete_event", self.delete_event)
	self.winrm.set_position(gtk.WIN_POS_MOUSE)
	self.winrm.set_default_size(491, 280)
        self.winrm.set_resizable(True)
        self.winrm.set_title(self.config.get('LanguageFile','51').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.winrm.set_modal(True)
	self.winrm.set_transient_for(self.winsc)
	
	#Main Table
	self.maintable2 = gtk.Table(2, 2, False)
	
	#Notebook
	self.rmnotebook = gtk.Notebook()
	self.rmnotebook.set_tab_pos(gtk.POS_TOP)
	
	#Table
	self.cookietable = gtk.Table(3, 5, False)
	
	#ListStore
        self.cookiestore = gtk.ListStore(gtk.gdk.Pixbuf, bool, str, str, str, int)
	dmitem = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'dm.png')
	dmpoitem = gtk.gdk.pixbuf_new_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'dmpo.png')
	
	#Append objects
	if 'True' in self.sciceye:
		if self.potnums != 0:
			totid = int(self.dbt)
			curid = 1
			ico = 1
			totfid = open('Data' + self.sysep + 'potconf.dll', 'r')
			totfid = totfid.readlines()
			totfid = len(totfid) - 1
			self.potdef = ConfigParser.ConfigParser()
                        self.potdef.read("Data" + self.sysep + "potconf.dll")
			
			while curid <= totfid:
				self.cookiestore.append([dmpoitem ,False, self.potdef.get('PotConf', str(curid + 1)), self.potdef.get('PotConf', str(curid)), self.config.get('LanguageFile','87').decode(locale.getpreferredencoding()).encode("utf-8"), int(totid + ico)])
	                        curid = curid + 3
				ico = ico + 1
	c = 0
	c = c + 1
	for z in self.defound:
		if z == '1':
			dmnum = self.LinkDatabase['dm' + str(c)]
			pr = dmnum[3]
                        if pr == '1':
				priority = '67'
			if pr == '2':
				priority = '66'
			if pr == '3':
				priority = '65'
			
			#Append
			self.cookiestore.append([dmitem ,False, dmnum[1], dmnum[0], self.config.get('LanguageFile',priority).decode(locale.getpreferredencoding()).encode("utf-8"), int(c)])
		c = c + 1	 
	#TreeView
	self.cookieview = gtk.TreeView(self.cookiestore)
	self.cookieview.set_rules_hint(True)
	
	#TreeViewColums
	self.column1 = gtk.TreeViewColumn('          ')
	self.column1.set_resizable(True)
	self.column2 = gtk.TreeViewColumn(self.config.get('LanguageFile','52').decode(locale.getpreferredencoding()).encode("utf-8") + '    ')
	self.column2.set_resizable(True)
	self.column3 = gtk.TreeViewColumn(self.config.get('LanguageFile','53').decode(locale.getpreferredencoding()).encode("utf-8") + '           ')
	self.column3.set_resizable(True)
	self.column4 = gtk.TreeViewColumn(self.config.get('LanguageFile','54').decode(locale.getpreferredencoding()).encode("utf-8") + '    ')
	self.columnid = gtk.TreeViewColumn(None)
	self.columnid.set_visible(False)
	
	#Append columns
	self.cookieview.append_column(self.column1)
	self.cookieview.append_column(self.column2)
	self.cookieview.append_column(self.column3)
	self.cookieview.append_column(self.column4)
	self.cookieview.append_column(self.columnid)
	
	#Cellrenderers2
	self.cell1 = gtk.CellRendererPixbuf()
	self.cell2 = gtk.CellRendererToggle()
	self.cell2.set_property('activatable', True)
	self.cell2.connect('toggled', self.check, iter)
	self.cell3 = gtk.CellRendererText()
	self.cell4 = gtk.CellRendererText()
	self.cell5 = gtk.CellRendererText()
	self.cell6 = gtk.CellRendererText()
	
	#add cell renderers
	self.column1.pack_start(self.cell1, True)
	self.column1.pack_start(self.cell2, True)
	self.column2.pack_start(self.cell3, True)
	self.column3.pack_start(self.cell4, True)
	self.column4.pack_start(self.cell5, True)
	self.columnid.pack_start(self.cell6, True)
	
	#set attributes
	self.column1.set_attributes(self.cell1, pixbuf=0)
	self.column1.set_attributes(self.cell2, active=1)
	self.column2.set_attributes(self.cell3, text=2)
	self.column3.set_attributes(self.cell4, text=3)
	self.column4.set_attributes(self.cell5, text=4)
	self.columnid.set_attributes(self.cell6, text=5)
	self.cell1.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
	
	#Box Button Remove sel
	self.rmtbox = gtk.HBox(False, 0)
	self.rmtimage = gtk.Image()
	self.rmtimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'removesel.png')
	self.rmtlab = gtk.Label('  ' + self.config.get('LanguageFile','55').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.rmtbox.pack_start(self.rmtimage, False, 1)
	self.rmtbox.pack_start(self.rmtlab, True, 1)
	self.rmtbut = gtk.Button()
	self.rmtbut.add(self.rmtbox)
	self.rmtbut.connect('clicked', self.removesele)
	
	#Box Button Select all
	self.seabox = gtk.HBox(False, 0)
	self.seaimage = gtk.Image()
	self.seaimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'selectall.png')
	self.sealab = gtk.Label('  ' + self.config.get('LanguageFile','56').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.seabox.pack_start(self.seaimage, False, 1)
	self.seabox.pack_start(self.sealab, True, 1)
	self.seabut = gtk.Button()
	self.seabut.add(self.seabox)
	self.seabut.connect('clicked', self.Select_all)
	
	#Box Button Close
	self.closebox01 = gtk.HBox(False, 0)
	self.closeimage01 = gtk.Image()
	self.closeimage01.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	self.closelab01 = gtk.Label('  ' + self.config.get('LanguageFile','37').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.closebox01.pack_start(self.closeimage01, False, 1)
	self.closebox01.pack_start(self.closelab01, True, 1)
	self.closebut01= gtk.Button()
	self.closebut01.add(self.closebox01)
	self.closebut01.connect("clicked", self.rmchecked, self)
	self.closebut01.connect_object("clicked", gtk.Widget.destroy, self.winrm)
	
	#Label
	self.rmlabel = gtk.Label(self.config.get('LanguageFile','57').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	#Button box
	self.brbox = gtk.HBox(False, 0)
	self.brbox.pack_start(self.rmtbut, False, 1)
	self.brbox.pack_start(self.seabut, False, 1)
	self.brbox.pack_start(self.closebut01, False, 1)
	
	#Scrolled Window
	self.swin = gtk.ScrolledWindow(None, None)
	self.swin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	self.swin.add(self.cookieview)
	
	#Table show
	self.cookietable.attach(self.swin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	self.cookietable.attach(self.rmlabel, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
	self.cookietable.attach(self.brbox, 2, 3, 1, 2, gtk.FILL|gtk.FILL, gtk.FILL)
	
	#Label box Remove
	self.rremovebox = gtk.HBox(False, 0)
	self.rremoveimage = gtk.Image()
	self.rremoveimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'rmtool.png')
	self.rremovelab = gtk.Label(' ' + self.config.get('LanguageFile','91').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.rremoveimage.show()
	self.rremovelab.show()
	self.rremovebox.pack_start(self.rremoveimage, True, 1)
	self.rremovebox.pack_start(self.rremovelab, False, 1)
	
	apprisk = False
	if 'True' in self.sciceye:
		if 'True' in self.scavv:
		    if self.riskf is True:
			#Table
	                self.risktable = gtk.Table(3, 5, False)
	
	                #ListStore
                        self.riskstore = gtk.ListStore(gtk.gdk.Pixbuf, bool, str, str, str, int)
			
			#Append objects
			curid = 1
			ico = 1
			totfid = open('Data' + self.sysep + 'potconf.dll', 'r')
			totfid = totfid.readlines()
			totfid = len(totfid) - 1
			self.potdef = ConfigParser.ConfigParser()
                        self.potdef.read("Data" + self.sysep + "potconf.dll")
			
			while curid <= totfid:
				self.riskstore.append([dmpoitem ,False, self.potdef.get('PotConf', str(curid + 1)), self.potdef.get('PotConf', str(curid)), self.config.get('LanguageFile','87').decode(locale.getpreferredencoding()).encode("utf-8"), int(ico)])
	                        curid = curid + 3
				ico = ico + 1
			    
			#TreeView
	                self.riskview = gtk.TreeView(self.riskstore)
	                self.riskview.set_rules_hint(True)
	
	                #TreeViewColums
	                self.column001 = gtk.TreeViewColumn('          ')
	                self.column001.set_resizable(True)
	                self.column002 = gtk.TreeViewColumn(self.config.get('LanguageFile','52').decode(locale.getpreferredencoding()).encode("utf-8") + '    ')
	                self.column002.set_resizable(True)
	                self.column003 = gtk.TreeViewColumn(self.config.get('LanguageFile','53').decode(locale.getpreferredencoding()).encode("utf-8") + '           ')
	                self.column003.set_resizable(True)
	                self.column004 = gtk.TreeViewColumn(self.config.get('LanguageFile','54').decode(locale.getpreferredencoding()).encode("utf-8") + '    ')
	                self.columnid2 = gtk.TreeViewColumn(None)
	                self.columnid2.set_visible(False)
	
	                #Append columns
	                self.riskview.append_column(self.column001)
	                self.riskview.append_column(self.column002)
	                self.riskview.append_column(self.column003)
	                self.riskview.append_column(self.column004)
	                self.riskview.append_column(self.columnid2)
	
	                #Cellrenderers2
	                self.cell001 = gtk.CellRendererPixbuf()
	                self.cell002 = gtk.CellRendererToggle()
	                self.cell002.set_property('activatable', True)
	                self.cell002.connect('toggled', self.ocheck, iter)
	                self.cell003 = gtk.CellRendererText()
	                self.cell004 = gtk.CellRendererText()
	                self.cell005 = gtk.CellRendererText()
	                self.cell006 = gtk.CellRendererText()
	
	                #add cell renderers
	                self.column001.pack_start(self.cell001, True)
	                self.column001.pack_start(self.cell002, True)
	                self.column002.pack_start(self.cell003, True)
	                self.column003.pack_start(self.cell004, True)
	                self.column004.pack_start(self.cell005, True)
	                self.columnid2.pack_start(self.cell006, True)
	
	                #set attributes
	                self.column001.set_attributes(self.cell001, pixbuf=0)
	                self.column001.set_attributes(self.cell002, active=1)
	                self.column002.set_attributes(self.cell003, text=2)
	                self.column003.set_attributes(self.cell004, text=3)
	                self.column004.set_attributes(self.cell005, text=4)
	                self.columnid2.set_attributes(self.cell006, text=5)
	                self.cell001.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
	
	                #Box Button Signal sel
	                self.rmtbox2 = gtk.HBox(False, 0)
	                self.rmtimage2 = gtk.Image()
	                self.rmtimage2.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'send.png')
	                self.rmtlab2 = gtk.Label('  ' + self.config.get('LanguageFile','88').decode(locale.getpreferredencoding()).encode("utf-8"))
	                self.rmtbox2.pack_start(self.rmtimage2, False, 1)
	                self.rmtbox2.pack_start(self.rmtlab2, True, 1)
	                self.rmtbut2 = gtk.Button()
	                self.rmtbut2.add(self.rmtbox2)
	                self.rmtbut2.connect('clicked', self.signal)
	
	                #Box Button Select all
	                self.seabox2 = gtk.HBox(False, 0)
	                self.seaimage2 = gtk.Image()
	                self.seaimage2.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'selectall.png')
	                self.sealab2 = gtk.Label('  ' + self.config.get('LanguageFile','56').decode(locale.getpreferredencoding()).encode("utf-8"))
	                self.seabox2.pack_start(self.seaimage2, False, 1)
	                self.seabox2.pack_start(self.sealab2, True, 1)
	                self.seabut2 = gtk.Button()
	                self.seabut2.add(self.seabox2)
	                self.seabut2.connect('clicked', self.Select_allr)
	
	                #Box Button Close
	                self.closebox001 = gtk.HBox(False, 0)
	                self.closeimage001 = gtk.Image()
	                self.closeimage001.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	                self.closelab001 = gtk.Label('  ' + self.config.get('LanguageFile','37').decode(locale.getpreferredencoding()).encode("utf-8"))
	                self.closebox001.pack_start(self.closeimage001, False, 1)
	                self.closebox001.pack_start(self.closelab001, True, 1)
	                self.closebut001= gtk.Button()
	                self.closebut001.add(self.closebox001)
	                self.closebut001.connect("clicked", self.rmchecked, self)
	                self.closebut001.connect_object("clicked", gtk.Widget.destroy, self.winrm)
	
	                #Label
	                self.rmlabel2 = gtk.Label(self.config.get('LanguageFile','89').decode(locale.getpreferredencoding()).encode("utf-8"))
	
	                #Button box
	                self.brbox2 = gtk.HBox(False, 0)
	                self.brbox2.pack_start(self.rmtbut2, False, 1)
	                self.brbox2.pack_start(self.seabut2, False, 1)
	                self.brbox2.pack_start(self.closebut001, False, 1)
	
	                #Scrolled Window
	                self.swin2 = gtk.ScrolledWindow(None, None)
	                self.swin2.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	                self.swin2.add(self.riskview)
	
	                #Table show
	                self.risktable.attach(self.swin2, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	                self.risktable.attach(self.rmlabel2, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
	                self.risktable.attach(self.brbox2, 2, 3, 1, 2, gtk.FILL|gtk.FILL, gtk.FILL)   
			    
			#Label box Signal
	                self.signalbox = gtk.HBox(False, 0)
	                self.signalimage = gtk.Image()
	                self.signalimage.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'signal.png')
	                self.signallab = gtk.Label(' ' + self.config.get('LanguageFile','90').decode(locale.getpreferredencoding()).encode("utf-8"))
	                self.signalimage.show()
	                self.signallab.show()
	                self.signalbox.pack_start(self.signalimage, True, 1)
	                self.signalbox.pack_start(self.signallab, False, 1)
			apprisk = True
	
	#Append pages
	self.rmnotebook.append_page(self.cookietable, self.rremovebox)
	if apprisk is True:
	 self.rmnotebook.append_page(self.risktable, self.signalbox)
	
	self.winrm.add(self.rmnotebook)
	self.winrm.show_all()
	
	#Focus
	self.winrm.set_focus(self.cookieview)
	
    def check(self,widget,iter,data=None):
	ID = self.cookiestore.get_value(self.cookiestore.get_iter(iter),5)
	
	if ID <= int(self.dbt):
	 if self.cookiestore.get_value(self.cookiestore.get_iter(iter),1) is True:
	   self.decheck= self.decheck[0: ID - 1] + '0' + self.decheck[ID:len(self.decheck)]
	   self.cookiestore.set_value(self.cookiestore.get_iter(iter),1, False)
         else:
	   self.decheck= self.decheck[0: ID - 1] + '1' + self.decheck[ID:len(self.decheck)]
	   self.cookiestore.set_value(self.cookiestore.get_iter(iter),1, True)
	else:
          if self.cookiestore.get_value(self.cookiestore.get_iter(iter),1) is True:
	   self.pocheck= self.pocheck[0: ID - int(self.dbt) - 1] + '0' + self.pocheck[ID - int(self.dbt):len(self.pocheck)]
	   self.cookiestore.set_value(self.cookiestore.get_iter(iter),1, False)
          else:
	   self.pocheck= self.pocheck[0: ID - int(self.dbt) - 1] + '1' + self.pocheck[ID - int(self.dbt):len(self.pocheck)]
	   self.cookiestore.set_value(self.cookiestore.get_iter(iter),1, True)
	    
	  
    def ocheck(self,widget,iter,data=None):
	ID = self.riskstore.get_value(self.riskstore.get_iter(iter),5)
	 
	if self.riskstore.get_value(self.riskstore.get_iter(iter),1) is True:
	   self.richeck= self.richeck[0: ID - 1] + '0' + self.richeck[ID:len(self.richeck)]
	   self.riskstore.set_value(self.riskstore.get_iter(iter),1, False)
        else:
	   self.richeck= self.richeck[0: ID - 1] + '1' + self.richeck[ID:len(self.richeck)]
	   self.riskstore.set_value(self.riskstore.get_iter(iter),1, True)
	
		
    def removesele(self, widget):
	#Count deleted obj
	deleted = 0
	
	#Count deleted
        deleted = int(self.decheck.count('1')) + int(self.pocheck.count('1'))
	deleted = str(deleted)
	
	#Advert
	if self.scwrite == 'True':
		self.adv2 = self.config.get('LanguageFile','58').decode(locale.getpreferredencoding()).encode("utf-8")
	if self.scwrite == 'False':
		self.adv2 = self.config.get('LanguageFile','59').decode(locale.getpreferredencoding()).encode("utf-8")
	adv = self.config.get('LanguageFile','60').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' + deleted + '/' + str(self.objf) + ' ' + self.config.get('LanguageFile','61').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.adv2 + '\n' + '_______________\n' + self.config.get('LanguageFile','62').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','63').decode(locale.getpreferredencoding()).encode("utf-8")
		
	self.advert = gtk.MessageDialog(None, 0, gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, adv)
	self.advert.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.advert.set_modal(True)
	self.advert.set_transient_for(self.winsc)
	
		
	self.advert.show()
        resp = self.advert.run()
        if resp == gtk.RESPONSE_NO:
           self.advert.destroy()
	   
        if resp == gtk.RESPONSE_YES:
	   #Delete list file
	   self.nscan = self.nscan + 1
	   self.nrem = self.nrem + int(deleted)
	   b = 0
	   b = b + 1
	   l = 0
	   l = l + 1
	   self.nfound = self.nfound + int(self.defound.count('1')) + self.potnums
	   for k in self.decheck:
		if k == '1':
			self.cookiecon[int(self.delines[self.txtlen * (b - 1) : self.txtlen * b])] = 'remove'
			self.removelog = self.removelog + 1
			dmnum = self.LinkDatabase['dm' + str(b)]
			pri = dmnum[3]
                        if pri == '1':
				self.nrlow = self.nrlow + 1
				self.lowlog = self.lowlog + 1
			if pri == '2':
				self.nrmed = self.nrmed + 1
				self.medlog = self.medlog + 1
			if pri == '3':
				self.nrhigh = self.nrhigh + 1
				self.highlog = self.highlog + 1
		b = b + 1
	   if 'True' in self.sciceye:	
	      for w in self.pocheck:
		if w == '1':
			self.cookiecon[int(self.potdef.get('PotConf',str(3 * l)))] = 'remove'
			self.removelog = self.removelog + 1
			self.npot = self.npot + 1
			self.risklog = self.risklog + 1
		l = l + 1
		
	   listcookie = len(self.cookiecon)
	   ccookie = listcookie - 1
	   
	   #Delete cicle
	   while ccookie > 0:
		   currentcookie = self.cookiecon[ccookie]
		   if currentcookie == 'remove':
			del self.cookiecon[ccookie]
			listcookie = len(self.cookiecon)
			ccookie = listcookie - 1
		   else:
			ccookie = ccookie - 1
			
	   
           #Rewrite File cookie
	   cookiefile = open(self.spath, 'w')
	   cookiefile.flush()
	   cookiefile.writelines(self.cookiecon)
	   self.rewrite(self.rewrite)
	   self.refresh(self.refresh)
	   self.advert.destroy()
	   self.winrm.destroy()
	   self.winsc.destroy()
	   
	   #Write log
	   self.checklog = self.objc
	   if 'True' in self.scwrite:
		   self.write_log(self)
		   
           #Clear PotConf
	   potfile = open('Data' + self.sysep + 'potconf.dll','w')
	   potfile.flush()
	   potfile.close()
		   
	   
	self.advert.destroy()
	
	
    def signal(self, widget):
	#Count signal obj
	signalobjs = 0
	
	#Count signal
        signalobjs = int(self.richeck.count('1'))
	signalobjs = str(signalobjs)
	
	#Dialog Error
	self.errorv = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, self.config.get('LanguageFile','92').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.errorv.set_modal(True)
	self.errorv.set_transient_for(self.winsc)
	
	#Advert
	advv = self.config.get('LanguageFile','93').decode(locale.getpreferredencoding()).encode("utf-8") + ' ' + signalobjs + ' ' + self.config.get('LanguageFile','94').decode(locale.getpreferredencoding()).encode("utf-8") + '\n' + self.config.get('LanguageFile','95').decode(locale.getpreferredencoding()).encode("utf-8")
	self.advertv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO, advv)
	self.advertv.set_title(self.config.get('LanguageFile','64').decode(locale.getpreferredencoding()).encode("utf-8"))
        self.advertv.set_modal(True)
	self.advertv.set_transient_for(self.winsc)
	self.advertv.set_icon_from_file('Icons' + self.sysep + 'Ice_Eye.png')
	
	if int(signalobjs) == 0:
		self.errorv.show()
		resp = self.errorv.run()
                if resp == gtk.RESPONSE_CLOSE:
                      self.errorv.destroy()
		self.errorv.destroy()
	else:
	        self.advertv.show()
                resp = self.advertv.run()
                if resp == gtk.RESPONSE_NO:
                   self.advertv.destroy()
	   
                if resp == gtk.RESPONSE_YES:
		   #Generate url
		   l = 1
		   URLC = ['']
		   C = 0
		   for w in self.richeck:
		    if w == '1':
			URLD = self.cookiecon[int(self.potdef.get('PotConf',str(3 * l)))]
			URLD = URLD.replace('\t','PPTO')
			URLD = URLD.replace('\n','PPNO')
			URLD = URLD.replace('&','PPEO')
			URLD = URLD.replace('%','PPEO')
			URLD = URLD.replace('=','PPUO')
			URLD = URLD.replace('?','PPIO')
			#Limit
			if len(URLC[C] + URLD) >= 1800:
			     if len(URLD) <= 1800:
				#Add new message
				URLC.append('')
				URLC[C] = URLC[C] + '%0d%0a'
				C = C + 1
				URLC[C] = URLD + 'PPSO' 
			else:
				URLC[C] = URLC[C] + URLD + 'PPSO'
		    l = l + 1
		   URLC[C] = URLC[C] + '%0d%0a'
                   
                   #Verify Database version
                   self.database = ConfigParser.ConfigParser()
	           self.database.read("Data" + self.sysep + "ndefx.dll")
	           self.dbv = self.database.get('Definitions','dbv')
		   
		   #open email client
		   L = 0
		   ex = len(URLC)
		   for x in URLC:
	             ext = ''
	             if ex != 1:
			ext = '(' + str(L + 1) + '/' + str(ex) + ')'
		     webbrowser.open('mailto:nixory.signal@email.it?subject=Cookies objects signalling' + ext + '&body=' + URLC[L] + 'PPVOvv0.4.1-' + str(self.dbv) + 'PPOSO' + str(os.name) + '"')
		     L = L + 1
	        self.advertv.destroy()
	
		
	self.advertv.destroy()
    def rmchecked(self, widget, path):
	#Remove all checked
	self.decheck = '0' * int(self.dbt)
	self.pocheck = '0' * self.potnums
	self.richeck = '0' * self.potnums
	
	
    def Select_all(self, widget):
	#count iters
	it = self.cookiestore.get_iter_first()
        i=0
        while it:
          i=i+1
          it = self.cookiestore.iter_next(it)
	  
	#Set all True
	if 'True' in self.sciceye:
	    self.pocheck = '1' * self.potnums
	while i > 0:
	  ID = self.cookiestore.get_value(self.cookiestore.get_iter(i - 1),5)
	  
	  if ID <= int(self.dbt):
	   self.decheck= self.decheck[0: ID - 1] + '1' + self.decheck[ID:len(self.decheck)]
           self.cookiestore.set_value(self.cookiestore.get_iter(i - 1),1, True)
	  else:
           self.cookiestore.set_value(self.cookiestore.get_iter(i - 1),1, True)
	  i=i-1
	  
	  
    def Select_allr(self, widget):
	#count iters
	it = self.riskstore.get_iter_first()
        i=0
        while it:
          i=i+1
          it = self.riskstore.iter_next(it)
	  
	#Set all True
	if 'True' in self.sciceye:
	    self.richeck = '1' * self.potnums
	while i > 0:
	  ID = self.riskstore.get_value(self.riskstore.get_iter(i - 1),5)
          self.riskstore.set_value(self.riskstore.get_iter(i - 1),1, True)
	  i=i-1
	  
    def write_log(self,widget):
	#verify if exist
	self.datatime = os.path.isfile('History' + self.sysep + 'log.txt')
	if self.datatime is True:
           self.get_dt(self)
	   dateb = 'Date:: ' + str(self.day) + '/' + str(self.month) + '/' + str(self.year) + '\n'
	   timeb = 'Time:: ' + str(self.hour) + ':' + str(self.minute) + ':' + str(self.second) + '\n'
	   scantimeb = 'Scan Time:: ' + str(self.tot) + ' seconds\n'
	   foundb = 'Harmful Objets found:: ' + str(self.foundlog) + '\n'
	   removeb = 'Removed Objects:: ' + str(self.removelog) + '\n'
	   checkb = 'Checked Objects:: ' + str(self.checklog) + '\n'
	   lowb = 'Low priority objects removed:: ' + str(self.lowlog) + '\n'
	   medb = 'Medium priority objects removed:: ' + str(self.medlog) + '\n'
	   highb = 'High priority objects removed:: ' + str(self.highlog) + '\n'
	   riskb = 'Risk objects removed:: ' + str(self.risklog) + '\n'
	   ignoreb = 'Ignored objects:: ' + str(self.ignorelog) + '\n'
	   sep = ('*' * 10) + '\n'
	   
	   self.scanlog = ['::Scan log::\n',dateb, timeb, scantimeb, foundb, removeb ,checkb ,lowb ,medb ,highb ,riskb ,ignoreb ,sep]
	   
	   if 'True' in self.writedet:
            self.scanlog.append('Found Objects Details\n\n')
	    c = 0
	    c = c + 1
	    for z in self.defound:
		if z == '1':
			dmnum = self.LinkDatabase['dm' + str(c)]
			pr = dmnum[3]
                        if pr == '1':
				priority = 'Low'
			if pr == '2':
				priority = 'Medium'
			if pr == '3':
				priority = 'High'
			
			#Write
			if self.decheck[int(dmnum[2]) - 1] == '1':
				removed = 'Yes'
			else:
				removed = 'No'
			appen = 'Object Name: ' + dmnum[1] + '\n' + 'Object Http location: ' + dmnum[0] + '\n' + 'Type: Tracking cookie\n' + 'Priority: ' + priority + '\n' + 'Removed: ' + removed + '\n---------\n'
			self.scanlog.append(appen)
		c = c + 1
	   if 'True' in self.writedet:
            if 'True' in self.sciceye:
	     if self.potnums != 0:
	      self.potdef = ConfigParser.ConfigParser()
              self.potdef.read("Data" + self.sysep + "potconf.dll")
	      c = 0
	      c = c + 1
	      for z in self.pocheck:
		#Write
		if self.pocheck[c - 1] == '1':
			removed = 'Yes'
		else:
			removed = 'No'
		appen = 'Object Name: ' + self.potdef.get('PotConf', str(2 + (3 * (c - 1)))) + '\n' + 'Object Http location: ' + self.potdef.get('PotConf', str(1 + (3 * (c - 1)))) + '\n' + 'Type: Potentially Tracking cookie\n' + 'Priority: Unknow' + '\n' + 'Removed: ' + removed + '\n---------\n'
	        self.scanlog.append(appen)
		c = c + 1
	    
           self.scanlog.append('-' * 62)
           self.scanlog.append('\n\n')
           logi = open('History' + self.sysep + 'log.txt', 'r')
           line = logi.readlines()
           lines = line.count('-' * 62 + '\n')
	     
           if lines >= int(self.maxlogs[0:len(self.maxlogs) - 2]):
	      login = open('History' + self.sysep + 'log.txt', 'w')
	      login.writelines(self.scanlog)
           else:
	      login = open('History' + self.sysep + 'log.txt', 'w')
	      login.writelines(self.scanlog)
	      login = open('History' + self.sysep + 'log.txt', 'a')
	      login.writelines(line)
              
              
    def win_eventlog(self, widget):
        #Window
	self.winevl = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.winevl.connect("delete_event", self.delete_event)
	self.winevl.set_position(gtk.WIN_POS_CENTER)
        self.winevl.set_default_size(390, 228)
        self.winevl.set_resizable(True)
        self.winevl.set_title(self.config.get('LanguageFile','158').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.winevl.set_modal(True)
	self.winevl.set_transient_for(self.win)
        
        #Table
	self.evltable = gtk.Table(3, 5, False)
        
        #Add Pixbuf
	opterm = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "opt_s.png")
	opfail = gtk.gdk.pixbuf_new_from_file("Icons" + self.sysep + "Theme" + self.sysep + "opt_f.png")
	
        #ListStore
        self.evliststore = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
        
        #Read event log
        evls = os.path.isfile('Data' + self.sysep + 'evlog.dll')
        if evls:
           evlope = open('Data' + self.sysep + 'evlog.dll', 'r')
           evlelist = evlope.readlines()
           evlen = len(evlelist)
           evlen = evlen - 1
           kl = 0
           while kl <= evlen:
            cck = evlelist[kl]
            cck = cck[0:len(cck) - 1]
            cck = cck.split('\t')
            eventc = cck[0]
            datec = cck[1]
            timec = cck[2]
            if eventc == 'sc_s':
               self.evliststore.append([opterm ,self.config.get('LanguageFile','152').decode(locale.getpreferredencoding()).encode("utf-8"), str(datec), str(timec)])
            if eventc == 'sc_f':
               self.evliststore.append([opfail ,self.config.get('LanguageFile','153').decode(locale.getpreferredencoding()).encode("utf-8"), str(datec), str(timec)])
            if eventc == 'upd_s':
               dbcc = cck[3]
               self.evliststore.append([opterm ,self.config.get('LanguageFile','154').decode(locale.getpreferredencoding()).encode("utf-8") + str(dbcc), str(datec), str(timec)])
            if eventc == 'upd_f':
               self.evliststore.append([opfail ,self.config.get('LanguageFile','155').decode(locale.getpreferredencoding()).encode("utf-8"), str(datec), str(timec)])
            if eventc == 'log':
               self.evliststore.append([opterm ,self.config.get('LanguageFile','156').decode(locale.getpreferredencoding()).encode("utf-8"), str(datec), str(timec)])
            kl = kl + 1
            
	#TreeView
	self.evtreeview = gtk.TreeView(self.evliststore)
	self.evtreeview.set_rules_hint(True)
	
	#TreeViewColums
	self.colpix = gtk.TreeViewColumn('      ')
	self.colpix.set_resizable(True)
	self.colstr1 = gtk.TreeViewColumn(self.config.get('LanguageFile','149').decode(locale.getpreferredencoding()).encode("utf-8") + '             ')
        self.colstr2 = gtk.TreeViewColumn(self.config.get('LanguageFile','150').decode(locale.getpreferredencoding()).encode("utf-8") + '              ')
        self.colstr3 = gtk.TreeViewColumn(self.config.get('LanguageFile','151').decode(locale.getpreferredencoding()).encode("utf-8")+ '     ')
	
	#Append columns
	self.evtreeview.append_column(self.colpix)
	self.evtreeview.append_column(self.colstr1)
        self.evtreeview.append_column(self.colstr2)
        self.evtreeview.append_column(self.colstr3)        
	
	#Cellrenderers2
	self.cepix = gtk.CellRendererPixbuf()
	self.cestr1 = gtk.CellRendererText()
	self.cestr2 = gtk.CellRendererText()
        self.cestr3 = gtk.CellRendererText()
	
	#add cell renderers
	self.colpix.pack_start(self.cepix, True)
	self.colstr1.pack_start(self.cestr1, True)
	self.colstr2.pack_start(self.cestr2, True)
        self.colstr3.pack_start(self.cestr3, True)
	
	#set attributes
	self.colpix.set_attributes(self.cepix, pixbuf=0)
	self.colstr1.set_attributes(self.cestr1, text=1)
	self.colstr2.set_attributes(self.cestr2, text=2)
        self.colstr3.set_attributes(self.cestr3, text=3)
	self.cepix.set_property('stock-size', gtk.ICON_SIZE_SMALL_TOOLBAR)
        
        #Box Button Close
	self.evwclose = gtk.HBox(False, 0)
	self.evwcloseimg = gtk.Image()
	self.evwcloseimg.set_from_file('Icons' + self.sysep + 'Theme' + self.sysep + 'nope_small.png')
	self.evwcloselab = gtk.Label('   ' + self.config.get('LanguageFile','37').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.evwclose.pack_start(self.evwcloseimg, False, 1)
	self.evwclose.pack_start(self.evwcloselab, True, 1)
	self.evwclosebut = gtk.Button()
	self.evwclosebut.add(self.evwclose)
	self.evwclosebut.connect_object("clicked", gtk.Widget.destroy, self.winevl)
        
        #Label
        self.evllabel = gtk.Label(self.config.get('LanguageFile','157').decode(locale.getpreferredencoding()).encode("utf-8"))
	self.evswin = gtk.ScrolledWindow(None, None)
	self.evswin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	self.evswin.add(self.evtreeview)	
        
        #Table append
        self.evltable.attach(self.evswin, 0, 3, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	self.evltable.attach(self.evllabel, 0, 2, 1, 2, gtk.EXPAND|gtk.FILL, gtk.FILL)
	self.evltable.attach(self.evwclosebut, 2, 3, 1, 2, 0|0, 0)

        self.winevl.add(self.evltable)
        self.winevl.show_all()
	      
    def get_dt(self,widget):
        #Get Date and Time
        now = time.time()
        timedate = time.localtime(now)
        self.year = str(timedate[0])
        self.month = str(timedate[1])
        self.day = str(timedate[2])
        self.hour = str(timedate[3])
        self.minute = str(timedate[4])
        if len(self.minute) == 1:
            self.minute = '0' + self.minute
        self.second = str(timedate[5])
        if len(self.second) == 1:
            self.second = '0' + self.second
            
    def write_ev(self,loc):
        irrevl = os.path.isfile('Data' + self.sysep + 'evlog.dll')
        if irrevl:
            self.get_dt(self)
            evlop = open('Data' + self.sysep + 'evlog.dll', 'r')
            evlold = evlop.readlines()
            evlop = open('Data' + self.sysep + 'evlog.dll', 'w')
            
            #Get current dbv
            dhg = ConfigParser.ConfigParser()
            dhg.read("Data" + self.sysep + "ndefx.dll")
	    dbvn = dhg.get('Definitions','dbv')
            
            #Read event log
            if loc == 'upd_s':
               evlev = [str(loc) + '\t' + str(self.day) + '\\' + str(self.month) + '\\' + str(self.year) + '\t' + str(self.hour) + ':' + str(self.minute) + ':' + str(self.second) + '\t' + str(dbvn) + '\n']
            else:
               evlev = [str(loc) + '\t' + str(self.day) + '\\' + str(self.month) + '\\' + str(self.year) + '\t' + str(self.hour) + ':' + str(self.minute) + ':' + str(self.second) + '\n']
            evlop.writelines(evlev)
            evlop = open('Data' + self.sysep + 'evlog.dll', 'a')
            if len(evlold) >= 60:
                del evlold[59:len(evlold)]
                evlold[len(evlold) - 1] = evlold[len(evlold) - 1].replace('\n','')
            evlop.writelines(evlold)
            evlop.close()
	      
    def delete_event(self, widget, event, data=None):
        return False
    
    def destroy(self, widget, data=None):
        gtk.main_quit()
	
    def destroyw(self, widget, data=None):
	self.win.hide()
        gtk.main_quit()

    def main(self):
        gtk.main()

if __name__ == "__main__":
    loop = IndexWindow()
    loop.main()
